/******************************************************************************
 Copyright (C), 2015-2020, XM. Co., Ltd.
******************************************************************************
File Name	: xm_type.h
Version 		: Initial Draft
Author		: XM Isp software group
Created 		: 2017/04/07

Description 	: The common data type defination
Function List	:
History :
1.Date		: 2017/04/07
  Author		: Lycai
  Modification	: creat
******************************************************************************/
#ifndef __MPI_XMISP_H__
#define __MPI_XMISP_H__
typedef struct xmIR_DNC_ATTR_s
{
	int s32ColorExp;		// <s32ColorExp: to Color Mode
	int s32ColorDlt;
	int s32ColorDlt2;
	int s32BwExp;			// >s32BwExp: to BW Mode
	
}IR_DNC_ATTR_S;
typedef struct xmIR_DNC_INFO_s
{
#if(defined SOC_NONE) || (defined CHIPID_XM530)
	int s32Data[16];
#else
	int s32Data[6];
#endif
}IR_DNC_INFO_S;

typedef enum {
    tFALSE = 0,
    tTRUE  = 1,
} tBOOL;


typedef struct xmIR_FUNC_S
{
/**************************************
: ƵưԴ
:   u8Mode
			0: ر
			1: 
ز:	-1: 	
		0:		
		1:		Ч
**************************************/
    int(*pfn_led_ctrl)(unsigned char u8Mode);

/**************************************
: ȡư״̬
:  
:	*ps32Mode: 0:Auto 1:Manual
		* ps32State: 0:Close 1:Open
		
ز:	-1: 	
		0:		ɹ
**************************************/
	int(*pfn_led_get)(int *ps32Mode, int* ps32State);

/**************************************
: ҹ״̬ȡ
: *ps32State:  0: Day 1:Night
: 
ز:	-1: 	
		0:		ɹ
**************************************/
	int(*pfn_dnStatusExt_get)(int* ps32State);

} IR_FUNC_S;

typedef struct xmIR_CTRL_ATTR_S
{
	unsigned char u8Delay2Color;		// (s)
	unsigned char u8Delay2Bw;			// (s)
	unsigned char u8DelayLedReOpen;	// (s)
	unsigned char u8Mode;				// 0: No PhotoR  1: Have PhotoR  2: No PhotoR_V2  3: Have PhotoR_V2
	unsigned short u16PeriodMs;		// (ms)
} IR_CTRL_ATTR_S;


/*********************************************************************************
:	ȡҹ״̬
:	u8DnNow: ǰҹģʽ(ʵЧ)
					0: ɫ
					1: ڰ
				pstIrDncAttr
					s32ColorExp:  <=ֵɫģʽ
					s32ColorDlt:  	>=ֵɫģʽ
					s32ColorDlt2:	>=ֵɫģʽ(Example: 50)
					s32BwExp:	>=ֵڰģʽ
:	
ز:	-1:	
				0:	ɫ
				1:	ڰ
*********************************************************************************/
int XM_MPI_IR_GetDNCStatus(unsigned char u8DnNow, IR_DNC_ATTR_S* pstIrDncAttr);


/*********************************************************************************
:	ȡͳϢ
:	
:	pstDncInfo: ͳϢ
ز:	-1:	
				0:	ɫ
				1:	ڰ
*********************************************************************************/
int XM_MPI_IR_GetInfo(IR_DNC_INFO_S *pstDncInfo);

/*********************************************************************************
:	עưƽӿ
:	pstRegister: ָӿڵַ
:	
ز:	-1:	
		0:     ɹ
*********************************************************************************/
int XM_MPI_IR_FunCallBack(IR_FUNC_S *pstRegister);


/*********************************************************************************
:	ÿƲ
:	pstCtrlAttr: ָ
:	
ز:	-1:	
		0:     ɹ
*********************************************************************************/
int XM_MPI_IR_SetCtrlAttr(IR_CTRL_ATTR_S *pstCtrlAttr);


/*********************************************************************************
:	ȡƲ
:	
:	pstCtrlAttr: ָ
ز:	-1:	
		0:     ɹ
*********************************************************************************/
int XM_MPI_IR_GetCtrlAttr(IR_CTRL_ATTR_S *pstCtrlAttr);


/*********************************************************************************
:	лģʽ
:	u8Mode: 
					0: IR
					1: WL
:	
ز:	-1:	
				0:	ɹ
*********************************************************************************/
XM_S32 XM_MPI_IR_SwitchMode(XM_U8 u8Mode);


/*************************************************************************
: OSD Դӡʹ
: bEnable:
				0: Close
				1: Open
: 
ز: 0: ɹ
			  : 
*************************************************************************/
int XM_MPI_DBG_En(tBOOL bEnable);

/*************************************************************************
: OSD Դӡ
: 	u8Num:  ӡݸ
				*pu32Data: ָӡ
					ڵ1,2,3...u8Num
: 
ز: 0: ɹ
			  : 
*************************************************************************/
int XM_MPI_DBG_Task(unsigned char u8Num, unsigned int *pu32Data);

/*************************************************************************
: OSD ͷڴ
: 
: 
ز: 
*************************************************************************/
int XM_MPI_DBG_Release(XM_VOID);
#endif /* __MPI_XMISP_H__ */