//
//  "$Id: BlindDetect.h 4 2009-06-11 13:01:43Z liwj $"
//
//  Copyright (c)2008-2008, ZheJiang JuFeng Technology Stock CO.LTD.
//  All Rights Reserved.
//
//	Description:	
//	Revisions:		Year-Month-Day  SVN-Author  Modification
//

#ifndef __PAL_BLINDDETECT_H__
#define __PAL_BLINDDETECT_H__

#ifdef __cplusplus
extern "C" {
#endif

/// \defgroup BlindDetectAPI API Blind Detect
/// ȫΧȵڵӿڡ
///	\n ͼ:
/// \code
///    ===========================
///                |
///        *BlindDetectGetCaps
///                |
///         BlindDetectCreate
///    +-----------|
///    |   BlindDetectGetState
///    |   BlindDetectSetParameter
///    +-----------|
///       BlindDetectDestory
///                |
///    ===========================
/// \endcode
/// @{

/// 豸Խṹ
typedef struct BLIND_DETECT_CAPS
{
	unsigned int Enabled;			///< 1ʾֺ֧⣬0ʾֺ֧⡣
}BLIND_DETECT_CAPS;

/// 
typedef struct BLIND_DETECT_PARAM
{
	unsigned char	Level;            	///< ȼ	0 - 3 // 0 - 30
	int		Enable;				///< Ϊ1ʾʹܣΪ0ʱʾ
}BLIND_DETECT_PARAM;


/// 豸
/// 
/// \param 
/// \retval <0 ʧ
/// \retval 0 ɹ
int BlindDetectCreate(void);


/// ٺ豸
/// 
/// \param 
/// \retval <0 ʧ
/// \retval 0 ٳɹ
int BlindDetectDestory(void);


/// ִк⡣ء
/// 
/// \param [out] pData ָһunsigned intֵָ룬unsigned intֵǸͨƽ״̬
///       롣ͨڵλͨڸλߵƽ1͵ƽ0ڵͨ0
/// \retval 0  ɹ
/// \retval <0  ʧ
int BlindDetectGetState(unsigned int* pData);


/// úⲶĲ
/// 
/// \param [in] channel ͨš
/// \param [in] pParam ָṹBLIND_DETECT_ Paramָ롣
/// \retval 0  óɹ
/// \retval <0  ʧ
int BlindDetectSetParameter(int channel, BLIND_DETECT_PARAM *pParam);


/// õֵ֧ԡ
/// 
/// \param [out] pCaps ָԽṹBLIND_DETECT _CAPSָ롣
/// \retval 0  ȡɹ
/// \retval <0  ȡʧܡ
int BlindDetectGetCaps(BLIND_DETECT_CAPS * pCaps);

/// @} end of group

#ifdef __cplusplus
}
#endif

#endif 
