#ifndef _ISP_TOOLFLASH_H_
#define _ISP_TOOLFLASH_H_

#define F_DEBUG_BASE		0xF8E00000
#define FLASH_ADDR_ISP			0x18000
#define FLASH_ADDR_MENU		0x1C000

/********************************************************************************************
1. 2DNr
********************************************************************************************/
//2DNr (Color)
#define NR2D_COLOR_BASE						(F_DEBUG_BASE+0x000)
#define NR2D_COLOR_ENABLE				 		(NR2D_COLOR_BASE+0x002)
#define NR2D_COLOR_OPTYPE				 		(NR2D_COLOR_BASE+0x004)
#define NR2D_COLOR_MANUAL_THR		 			(NR2D_COLOR_BASE+0x006)
#define NR2D_COLOR_AUTO_THR0  	 				(NR2D_COLOR_BASE+0x008)
#define NR2D_COLOR_AUTO_THR1 		 			(NR2D_COLOR_BASE+0x00A)
#define NR2D_COLOR_AUTO_THR2  	 				(NR2D_COLOR_BASE+0x00C)
#define NR2D_COLOR_AUTO_THR3  	 				(NR2D_COLOR_BASE+0x00E)
#define NR2D_COLOR_AUTO_THR4  	 				(NR2D_COLOR_BASE+0x010)
#define NR2D_COLOR_AUTO_THR5  	 				(NR2D_COLOR_BASE+0x012)
#define NR2D_COLOR_AUTO_THR6  	 				(NR2D_COLOR_BASE+0x014)
#define NR2D_COLOR_AUTO_THR7  	 				(NR2D_COLOR_BASE+0x016)
#define NR2D_COLOR_AUTO_THR8  	 				(NR2D_COLOR_BASE+0x018)
#define NR2D_COLOR_AUTO_THR9  	 				(NR2D_COLOR_BASE+0x01A)
#define NR2D_COLOR_AUTO_THR10 	 				(NR2D_COLOR_BASE+0x01C)
#define NR2D_COLOR_AUTO_THR11 	 				(NR2D_COLOR_BASE+0x01E)
#define NR2D_COLOR_AUTO_THR12 	 				(NR2D_COLOR_BASE+0x020)
#define NR2D_COLOR_AUTO_THR13 	 				(NR2D_COLOR_BASE+0x022)
#define NR2D_COLOR_AUTO_THR14 	 				(NR2D_COLOR_BASE+0x024)
#define NR2D_COLOR_AUTO_THR15 	 				(NR2D_COLOR_BASE+0x026)

//2DNr (BW)     
#define NR2D_BW_BASE								(F_DEBUG_BASE+0x080)                                                     
#define NR2D_BW_ENABLE				 				(NR2D_BW_BASE+0x002) 
#define NR2D_BW_OPTYPE				 				(NR2D_BW_BASE+0x004) 
#define NR2D_BW_MANUAL_THR		 				(NR2D_BW_BASE+0x006) 
#define NR2D_BW_AUTO_THR0  	 					(NR2D_BW_BASE+0x008) 
#define NR2D_BW_AUTO_THR1 		 					(NR2D_BW_BASE+0x00A) 
#define NR2D_BW_AUTO_THR2  	 					(NR2D_BW_BASE+0x00C) 
#define NR2D_BW_AUTO_THR3  	 					(NR2D_BW_BASE+0x00E) 
#define NR2D_BW_AUTO_THR4  	 					(NR2D_BW_BASE+0x010) 
#define NR2D_BW_AUTO_THR5  	 					(NR2D_BW_BASE+0x012) 
#define NR2D_BW_AUTO_THR6  	 					(NR2D_BW_BASE+0x014) 
#define NR2D_BW_AUTO_THR7  	 					(NR2D_BW_BASE+0x016) 
#define NR2D_BW_AUTO_THR8  	 					(NR2D_BW_BASE+0x018) 
#define NR2D_BW_AUTO_THR9  	 					(NR2D_BW_BASE+0x01A) 
#define NR2D_BW_AUTO_THR10 	 					(NR2D_BW_BASE+0x01C) 
#define NR2D_BW_AUTO_THR11 	 					(NR2D_BW_BASE+0x01E) 
#define NR2D_BW_AUTO_THR12 	 					(NR2D_BW_BASE+0x020) 
#define NR2D_BW_AUTO_THR13 	 					(NR2D_BW_BASE+0x022) 
#define NR2D_BW_AUTO_THR14 	 					(NR2D_BW_BASE+0x024) 
#define NR2D_BW_AUTO_THR15 	 					(NR2D_BW_BASE+0x026) 

/********************************************************************************************
2. 3D Nr
********************************************************************************************/
//3DNr (Color)
#define NR3D_COLOR_BASE						(F_DEBUG_BASE+0x030)
#define NR3D_COLOR_ENABLE				 		(NR3D_COLOR_BASE+0x002)
#define NR3D_COLOR_OPTYPE				 		(NR3D_COLOR_BASE+0x004)
#define NR3D_COLOR_MANUAL_TF		 			(NR3D_COLOR_BASE+0x006)
#define NR3D_COLOR_MANUAL_SF		 			(NR3D_COLOR_BASE+0x008)
#define NR3D_COLOR_AUTO_TF0  	 				(NR3D_COLOR_BASE+0x00A)
#define NR3D_COLOR_AUTO_TF1 		 			(NR3D_COLOR_BASE+0x00C)
#define NR3D_COLOR_AUTO_TF2  	 				(NR3D_COLOR_BASE+0x00E)
#define NR3D_COLOR_AUTO_TF3  	 				(NR3D_COLOR_BASE+0x010)
#define NR3D_COLOR_AUTO_TF4  	 				(NR3D_COLOR_BASE+0x012)
#define NR3D_COLOR_AUTO_TF5  	 				(NR3D_COLOR_BASE+0x014)
#define NR3D_COLOR_AUTO_TF6  	 				(NR3D_COLOR_BASE+0x016)
#define NR3D_COLOR_AUTO_TF7  	 				(NR3D_COLOR_BASE+0x018)
#define NR3D_COLOR_AUTO_TF8  	 				(NR3D_COLOR_BASE+0x01A)
#define NR3D_COLOR_AUTO_TF9  	 				(NR3D_COLOR_BASE+0x01C)
#define NR3D_COLOR_AUTO_TF10 	 				(NR3D_COLOR_BASE+0x01E)
#define NR3D_COLOR_AUTO_TF11 	 				(NR3D_COLOR_BASE+0x020)
#define NR3D_COLOR_AUTO_TF12 	 				(NR3D_COLOR_BASE+0x022)
#define NR3D_COLOR_AUTO_TF13 	 				(NR3D_COLOR_BASE+0x024)
#define NR3D_COLOR_AUTO_TF14 	 				(NR3D_COLOR_BASE+0x026)
#define NR3D_COLOR_AUTO_TF15 	 				(NR3D_COLOR_BASE+0x028)
	
#define NR3D_COLOR_AUTO_SF0  	 				(NR3D_COLOR_BASE+0x02A)
#define NR3D_COLOR_AUTO_SF1 		 			(NR3D_COLOR_BASE+0x02C)
#define NR3D_COLOR_AUTO_SF2  	 				(NR3D_COLOR_BASE+0x02E)
#define NR3D_COLOR_AUTO_SF3  	 				(NR3D_COLOR_BASE+0x030)
#define NR3D_COLOR_AUTO_SF4  	 				(NR3D_COLOR_BASE+0x032)
#define NR3D_COLOR_AUTO_SF5  	 				(NR3D_COLOR_BASE+0x034)
#define NR3D_COLOR_AUTO_SF6  	 				(NR3D_COLOR_BASE+0x036)
#define NR3D_COLOR_AUTO_SF7  	 				(NR3D_COLOR_BASE+0x038)
#define NR3D_COLOR_AUTO_SF8  	 				(NR3D_COLOR_BASE+0x03A)
#define NR3D_COLOR_AUTO_SF9  	 				(NR3D_COLOR_BASE+0x03C)
#define NR3D_COLOR_AUTO_SF10 	 				(NR3D_COLOR_BASE+0x03E)
#define NR3D_COLOR_AUTO_SF11 	 				(NR3D_COLOR_BASE+0x040)
#define NR3D_COLOR_AUTO_SF12 	 				(NR3D_COLOR_BASE+0x042)
#define NR3D_COLOR_AUTO_SF13 	 				(NR3D_COLOR_BASE+0x044)
#define NR3D_COLOR_AUTO_SF14 	 				(NR3D_COLOR_BASE+0x046)
#define NR3D_COLOR_AUTO_SF15 	 				(NR3D_COLOR_BASE+0x048)
	
//3DNr (BW) 	
#define NR3D_BW_BASE						(F_DEBUG_BASE+0x0B0)
#define NR3D_BW_ENABLE				 		(NR3D_BW_BASE+0x002)
#define NR3D_BW_OPTYPE				 		(NR3D_BW_BASE+0x004)
#define NR3D_BW_MANUAL_TF		 			(NR3D_BW_BASE+0x006)
#define NR3D_BW_MANUAL_SF		 			(NR3D_BW_BASE+0x008)
#define NR3D_BW_AUTO_TF0  	 				(NR3D_BW_BASE+0x00A)
#define NR3D_BW_AUTO_TF1 		 			(NR3D_BW_BASE+0x00C)
#define NR3D_BW_AUTO_TF2  	 				(NR3D_BW_BASE+0x00E)
#define NR3D_BW_AUTO_TF3  	 				(NR3D_BW_BASE+0x010)
#define NR3D_BW_AUTO_TF4  	 				(NR3D_BW_BASE+0x012)
#define NR3D_BW_AUTO_TF5  	 				(NR3D_BW_BASE+0x014)
#define NR3D_BW_AUTO_TF6  	 				(NR3D_BW_BASE+0x016)
#define NR3D_BW_AUTO_TF7  	 				(NR3D_BW_BASE+0x018)
#define NR3D_BW_AUTO_TF8  	 				(NR3D_BW_BASE+0x01A)
#define NR3D_BW_AUTO_TF9  	 				(NR3D_BW_BASE+0x01C)
#define NR3D_BW_AUTO_TF10 	 				(NR3D_BW_BASE+0x01E)
#define NR3D_BW_AUTO_TF11 	 				(NR3D_BW_BASE+0x020)
#define NR3D_BW_AUTO_TF12 	 				(NR3D_BW_BASE+0x022)
#define NR3D_BW_AUTO_TF13 	 				(NR3D_BW_BASE+0x024)
#define NR3D_BW_AUTO_TF14 	 				(NR3D_BW_BASE+0x026)
#define NR3D_BW_AUTO_TF15 	 				(NR3D_BW_BASE+0x028)
	
#define NR3D_BW_AUTO_SF0  	 				(NR3D_BW_BASE+0x02A)
#define NR3D_BW_AUTO_SF1 		 			(NR3D_BW_BASE+0x02C)
#define NR3D_BW_AUTO_SF2  	 				(NR3D_BW_BASE+0x02E)
#define NR3D_BW_AUTO_SF3  	 				(NR3D_BW_BASE+0x030)
#define NR3D_BW_AUTO_SF4  	 				(NR3D_BW_BASE+0x032)
#define NR3D_BW_AUTO_SF5  	 				(NR3D_BW_BASE+0x034)
#define NR3D_BW_AUTO_SF6  	 				(NR3D_BW_BASE+0x036)
#define NR3D_BW_AUTO_SF7  	 				(NR3D_BW_BASE+0x038)
#define NR3D_BW_AUTO_SF8  	 				(NR3D_BW_BASE+0x03A)
#define NR3D_BW_AUTO_SF9  	 				(NR3D_BW_BASE+0x03C)
#define NR3D_BW_AUTO_SF10 	 				(NR3D_BW_BASE+0x03E)
#define NR3D_BW_AUTO_SF11 	 				(NR3D_BW_BASE+0x040)
#define NR3D_BW_AUTO_SF12 	 				(NR3D_BW_BASE+0x042)
#define NR3D_BW_AUTO_SF13 	 				(NR3D_BW_BASE+0x044)
#define NR3D_BW_AUTO_SF14 	 				(NR3D_BW_BASE+0x046)
#define NR3D_BW_AUTO_SF15 	 				(NR3D_BW_BASE+0x048)


/********************************************************************************************
2. Sharpness
********************************************************************************************/
//Sharpness (Color)
#define SHARP_COLOR_BASE				(F_DEBUG_BASE+0x100)
#define SHARP_COLOR_ENABLE				(SHARP_COLOR_BASE+0x002)
#define SHARP_COLOR_OPTYPE        		(SHARP_COLOR_BASE+0x004)
#define SHARP_COLOR_MANUAL_D			(SHARP_COLOR_BASE+0x006)
#define SHARP_COLOR_MANUAL_UD	    		(SHARP_COLOR_BASE+0x008)
#define SHARP_COLOR_MANUAL_KD			(SHARP_COLOR_BASE+0x00A)
#define SHARP_COLOR_AUTO_D0  			(SHARP_COLOR_BASE+0x00C)
#define SHARP_COLOR_AUTO_D1             	(SHARP_COLOR_BASE+0x00E)
#define SHARP_COLOR_AUTO_D2             	(SHARP_COLOR_BASE+0x010)
#define SHARP_COLOR_AUTO_D3             	(SHARP_COLOR_BASE+0x012)
#define SHARP_COLOR_AUTO_D4             	(SHARP_COLOR_BASE+0x014)
#define SHARP_COLOR_AUTO_D5             	(SHARP_COLOR_BASE+0x016)
#define SHARP_COLOR_AUTO_D6             	(SHARP_COLOR_BASE+0x018)
#define SHARP_COLOR_AUTO_D7             	(SHARP_COLOR_BASE+0x01A)
#define SHARP_COLOR_AUTO_D8             	(SHARP_COLOR_BASE+0x01C)
#define SHARP_COLOR_AUTO_D9             	(SHARP_COLOR_BASE+0x01E)
#define SHARP_COLOR_AUTO_D10          	 	(SHARP_COLOR_BASE+0x020)
#define SHARP_COLOR_AUTO_D11            	(SHARP_COLOR_BASE+0x022)
#define SHARP_COLOR_AUTO_D12            	(SHARP_COLOR_BASE+0x024)
#define SHARP_COLOR_AUTO_D13            	(SHARP_COLOR_BASE+0x026)
#define SHARP_COLOR_AUTO_D14    	 	(SHARP_COLOR_BASE+0x028)
#define SHARP_COLOR_AUTO_D15            	(SHARP_COLOR_BASE+0x02A)
#define SHARP_COLOR_AUTO_UD0            	(SHARP_COLOR_BASE+0x02C)
#define SHARP_COLOR_AUTO_UD1            	(SHARP_COLOR_BASE+0x02E)
#define SHARP_COLOR_AUTO_UD2            	(SHARP_COLOR_BASE+0x030)
#define SHARP_COLOR_AUTO_UD3            	(SHARP_COLOR_BASE+0x032)
#define SHARP_COLOR_AUTO_UD4            	(SHARP_COLOR_BASE+0x034)
#define SHARP_COLOR_AUTO_UD5            	(SHARP_COLOR_BASE+0x036)
#define SHARP_COLOR_AUTO_UD6            	(SHARP_COLOR_BASE+0x038)
#define SHARP_COLOR_AUTO_UD7            	(SHARP_COLOR_BASE+0x03A)
#define SHARP_COLOR_AUTO_UD8            	(SHARP_COLOR_BASE+0x03C)
#define SHARP_COLOR_AUTO_UD9            	(SHARP_COLOR_BASE+0x03E)
#define SHARP_COLOR_AUTO_UD10           	(SHARP_COLOR_BASE+0x040)
#define SHARP_COLOR_AUTO_UD11           	(SHARP_COLOR_BASE+0x042)
#define SHARP_COLOR_AUTO_UD12           	(SHARP_COLOR_BASE+0x044)
#define SHARP_COLOR_AUTO_UD13           	(SHARP_COLOR_BASE+0x046)
#define SHARP_COLOR_AUTO_UD14           	(SHARP_COLOR_BASE+0x048)
#define SHARP_COLOR_AUTO_UD15           	(SHARP_COLOR_BASE+0x04A)
#define SHARP_COLOR_AUTO_KD0            	(SHARP_COLOR_BASE+0x04C)
#define SHARP_COLOR_AUTO_KD1            	(SHARP_COLOR_BASE+0x04E)
#define SHARP_COLOR_AUTO_KD2            	(SHARP_COLOR_BASE+0x050)
#define SHARP_COLOR_AUTO_KD3            	(SHARP_COLOR_BASE+0x052)
#define SHARP_COLOR_AUTO_KD4            	(SHARP_COLOR_BASE+0x054)
#define SHARP_COLOR_AUTO_KD5            	(SHARP_COLOR_BASE+0x056)
#define SHARP_COLOR_AUTO_KD6            	(SHARP_COLOR_BASE+0x058)
#define SHARP_COLOR_AUTO_KD7            	(SHARP_COLOR_BASE+0x05A)
#define SHARP_COLOR_AUTO_KD8           	(SHARP_COLOR_BASE+0x05C)
#define SHARP_COLOR_AUTO_KD9            	(SHARP_COLOR_BASE+0x05E)
#define SHARP_COLOR_AUTO_KD10           	(SHARP_COLOR_BASE+0x060)
#define SHARP_COLOR_AUTO_KD11           	(SHARP_COLOR_BASE+0x062)
#define SHARP_COLOR_AUTO_KD12           	(SHARP_COLOR_BASE+0x064)
#define SHARP_COLOR_AUTO_KD13           	(SHARP_COLOR_BASE+0x066)
#define SHARP_COLOR_AUTO_KD14           	(SHARP_COLOR_BASE+0x068)
#define SHARP_COLOR_AUTO_KD15	          	(SHARP_COLOR_BASE+0x06A)

//Sharpness (BW)   
#define SHARP_BW_BASE                	(F_DEBUG_BASE+0x180)                            
#define SHARP_BW_ENABLE		(SHARP_BW_BASE+0x002)
#define SHARP_BW_OPTYPE              (SHARP_BW_BASE+0x004)
#define SHARP_BW_MANUAL_D		(SHARP_BW_BASE+0x006)
#define SHARP_BW_MANUAL_UD	(SHARP_BW_BASE+0x008)
#define SHARP_BW_MANUAL_KD	(SHARP_BW_BASE+0x00A)
#define SHARP_BW_AUTO_D0  		(SHARP_BW_BASE+0x00C)
#define SHARP_BW_AUTO_D1           (SHARP_BW_BASE+0x00E)
#define SHARP_BW_AUTO_D2           (SHARP_BW_BASE+0x010)
#define SHARP_BW_AUTO_D3           (SHARP_BW_BASE+0x012)
#define SHARP_BW_AUTO_D4           (SHARP_BW_BASE+0x014)
#define SHARP_BW_AUTO_D5           (SHARP_BW_BASE+0x016)
#define SHARP_BW_AUTO_D6           (SHARP_BW_BASE+0x018)
#define SHARP_BW_AUTO_D7           (SHARP_BW_BASE+0x01A)
#define SHARP_BW_AUTO_D8           (SHARP_BW_BASE+0x01C)
#define SHARP_BW_AUTO_D9           (SHARP_BW_BASE+0x01E)
#define SHARP_BW_AUTO_D10         (SHARP_BW_BASE+0x020)
#define SHARP_BW_AUTO_D11         (SHARP_BW_BASE+0x022)
#define SHARP_BW_AUTO_D12         (SHARP_BW_BASE+0x024)
#define SHARP_BW_AUTO_D13         (SHARP_BW_BASE+0x026)
#define SHARP_BW_AUTO_D14    	(SHARP_BW_BASE+0x028)
#define SHARP_BW_AUTO_D15         (SHARP_BW_BASE+0x02A)
#define SHARP_BW_AUTO_UD0         (SHARP_BW_BASE+0x02C)
#define SHARP_BW_AUTO_UD1         (SHARP_BW_BASE+0x02E)
#define SHARP_BW_AUTO_UD2         (SHARP_BW_BASE+0x030)
#define SHARP_BW_AUTO_UD3         (SHARP_BW_BASE+0x032)
#define SHARP_BW_AUTO_UD4         (SHARP_BW_BASE+0x034)
#define SHARP_BW_AUTO_UD5         (SHARP_BW_BASE+0x036)
#define SHARP_BW_AUTO_UD6         (SHARP_BW_BASE+0x038)
#define SHARP_BW_AUTO_UD7         (SHARP_BW_BASE+0x03A)
#define SHARP_BW_AUTO_UD8         (SHARP_BW_BASE+0x03C)
#define SHARP_BW_AUTO_UD9         (SHARP_BW_BASE+0x03E)
#define SHARP_BW_AUTO_UD10       (SHARP_BW_BASE+0x040)
#define SHARP_BW_AUTO_UD11       (SHARP_BW_BASE+0x042)
#define SHARP_BW_AUTO_UD12       (SHARP_BW_BASE+0x044)
#define SHARP_BW_AUTO_UD13       (SHARP_BW_BASE+0x046)
#define SHARP_BW_AUTO_UD14       (SHARP_BW_BASE+0x048)
#define SHARP_BW_AUTO_UD15       (SHARP_BW_BASE+0x04A)
#define SHARP_BW_AUTO_KD0         (SHARP_BW_BASE+0x04C)
#define SHARP_BW_AUTO_KD1         (SHARP_BW_BASE+0x04E)
#define SHARP_BW_AUTO_KD2         (SHARP_BW_BASE+0x050)
#define SHARP_BW_AUTO_KD3         (SHARP_BW_BASE+0x052)
#define SHARP_BW_AUTO_KD4         (SHARP_BW_BASE+0x054)
#define SHARP_BW_AUTO_KD5         (SHARP_BW_BASE+0x056)
#define SHARP_BW_AUTO_KD6         (SHARP_BW_BASE+0x058)
#define SHARP_BW_AUTO_KD7         (SHARP_BW_BASE+0x05A)
#define SHARP_BW_AUTO_KD8         (SHARP_BW_BASE+0x05C)
#define SHARP_BW_AUTO_KD9         (SHARP_BW_BASE+0x05E)
#define SHARP_BW_AUTO_KD10       (SHARP_BW_BASE+0x060)
#define SHARP_BW_AUTO_KD11       (SHARP_BW_BASE+0x062)
#define SHARP_BW_AUTO_KD12       (SHARP_BW_BASE+0x064)
#define SHARP_BW_AUTO_KD13       (SHARP_BW_BASE+0x066)
#define SHARP_BW_AUTO_KD14       (SHARP_BW_BASE+0x068)
#define SHARP_BW_AUTO_KD15	(SHARP_BW_BASE+0x06A)                           

/********************************************************************************************
3. DyDpc
********************************************************************************************/
//DyDPC (Color)    
#define DDPC_COLOR_BASE				(F_DEBUG_BASE+0x200)
#define DDPC_COLOR_OPTYPE           		(DDPC_COLOR_BASE+0x002) 
#define DDPC_COLOR_MANUAL_STH		     	(DDPC_COLOR_BASE+0x004)         
#define DDPC_COLOR_AUTO_STH0         		(DDPC_COLOR_BASE+0x006) 
#define DDPC_COLOR_AUTO_STH1         		(DDPC_COLOR_BASE+0x008) 
#define DDPC_COLOR_AUTO_STH2         		(DDPC_COLOR_BASE+0x00A) 
#define DDPC_COLOR_AUTO_STH3         		(DDPC_COLOR_BASE+0x00C) 
#define DDPC_COLOR_AUTO_STH4         		(DDPC_COLOR_BASE+0x00E) 
#define DDPC_COLOR_AUTO_STH5         		(DDPC_COLOR_BASE+0x010) 
#define DDPC_COLOR_AUTO_STH6         		(DDPC_COLOR_BASE+0x012) 
#define DDPC_COLOR_AUTO_STH7         		(DDPC_COLOR_BASE+0x014) 
#define DDPC_COLOR_AUTO_STH8         		(DDPC_COLOR_BASE+0x016) 
#define DDPC_COLOR_AUTO_STH9         		(DDPC_COLOR_BASE+0x018) 
#define DDPC_COLOR_AUTO_STH10        		(DDPC_COLOR_BASE+0x01A) 
#define DDPC_COLOR_AUTO_STH11        		(DDPC_COLOR_BASE+0x01C) 
#define DDPC_COLOR_AUTO_STH12        		(DDPC_COLOR_BASE+0x01E) 
#define DDPC_COLOR_AUTO_STH13        		(DDPC_COLOR_BASE+0x020)
#define DDPC_COLOR_AUTO_STH14        		(DDPC_COLOR_BASE+0x022)
#define DDPC_COLOR_AUTO_STH15        		(DDPC_COLOR_BASE+0x024)


//DyDPC (BW)   
#define DDPC_BW_BASE					(F_DEBUG_BASE+0x280)
#define DDPC_BW_OPTYPE           			(DDPC_BW_BASE+0x002) 
#define DDPC_BW_MANUAL_STH		     	(DDPC_BW_BASE+0x004)         
#define DDPC_BW_AUTO_STH0         		(DDPC_BW_BASE+0x006) 
#define DDPC_BW_AUTO_STH1         		(DDPC_BW_BASE+0x008) 
#define DDPC_BW_AUTO_STH2         		(DDPC_BW_BASE+0x00A) 
#define DDPC_BW_AUTO_STH3         		(DDPC_BW_BASE+0x00C) 
#define DDPC_BW_AUTO_STH4         		(DDPC_BW_BASE+0x00E) 
#define DDPC_BW_AUTO_STH5         		(DDPC_BW_BASE+0x010) 
#define DDPC_BW_AUTO_STH6         		(DDPC_BW_BASE+0x012) 
#define DDPC_BW_AUTO_STH7         		(DDPC_BW_BASE+0x014) 
#define DDPC_BW_AUTO_STH8         		(DDPC_BW_BASE+0x016) 
#define DDPC_BW_AUTO_STH9         		(DDPC_BW_BASE+0x018) 
#define DDPC_BW_AUTO_STH10        		(DDPC_BW_BASE+0x01A) 
#define DDPC_BW_AUTO_STH11        		(DDPC_BW_BASE+0x01C) 
#define DDPC_BW_AUTO_STH12        		(DDPC_BW_BASE+0x01E) 
#define DDPC_BW_AUTO_STH13        		(DDPC_BW_BASE+0x020)
#define DDPC_BW_AUTO_STH14        		(DDPC_BW_BASE+0x022)
#define DDPC_BW_AUTO_STH15        		(DDPC_BW_BASE+0x024)
                                                                              

/********************************************************************************************
4. BlackLevel
********************************************************************************************/
//BlackLevel(Color)
#define BLC_COLOR_BASE					(F_DEBUG_BASE+0x300) 
#define BLC_COLOR_OPTYPE              		(BLC_COLOR_BASE+0x002) 
#define BLC_COLOR_MANUAL_BLC	        	(BLC_COLOR_BASE+0x004) 
#define BLC_COLOR_AUTO_BLC0  			(BLC_COLOR_BASE+0x006) 			
#define BLC_COLOR_AUTO_BLC1 			(BLC_COLOR_BASE+0x008) 			
#define BLC_COLOR_AUTO_BLC2  			(BLC_COLOR_BASE+0x00A) 			
#define BLC_COLOR_AUTO_BLC3  			(BLC_COLOR_BASE+0x00C) 			
#define BLC_COLOR_AUTO_BLC4  			(BLC_COLOR_BASE+0x00E) 			
#define BLC_COLOR_AUTO_BLC5  			(BLC_COLOR_BASE+0x010) 			
#define BLC_COLOR_AUTO_BLC6  			(BLC_COLOR_BASE+0x012) 			
#define BLC_COLOR_AUTO_BLC7  			(BLC_COLOR_BASE+0x014) 			
#define BLC_COLOR_AUTO_BLC8  			(BLC_COLOR_BASE+0x016) 			
#define BLC_COLOR_AUTO_BLC9  			(BLC_COLOR_BASE+0x018) 			
#define BLC_COLOR_AUTO_BLC10 			(BLC_COLOR_BASE+0x01A) 			
#define BLC_COLOR_AUTO_BLC11 			(BLC_COLOR_BASE+0x01C) 			
#define BLC_COLOR_AUTO_BLC12 			(BLC_COLOR_BASE+0x01E) 			
#define BLC_COLOR_AUTO_BLC13 			(BLC_COLOR_BASE+0x020) 			
#define BLC_COLOR_AUTO_BLC14 			(BLC_COLOR_BASE+0x022) 			
#define BLC_COLOR_AUTO_BLC15      		(BLC_COLOR_BASE+0x024)                                                               
//BlackLevel(BW)
#define BLC_BW_BASE					(F_DEBUG_BASE+0x380) 
#define BLC_BW_OPTYPE              		(BLC_BW_BASE+0x002) 
#define BLC_BW_MANUAL_BLC	        	(BLC_BW_BASE+0x004) 
#define BLC_BW_AUTO_BLC0  			(BLC_BW_BASE+0x006) 			
#define BLC_BW_AUTO_BLC1 			(BLC_BW_BASE+0x008) 			
#define BLC_BW_AUTO_BLC2  			(BLC_BW_BASE+0x00A) 			
#define BLC_BW_AUTO_BLC3  			(BLC_BW_BASE+0x00C) 			
#define BLC_BW_AUTO_BLC4  			(BLC_BW_BASE+0x00E) 			
#define BLC_BW_AUTO_BLC5  			(BLC_BW_BASE+0x010) 			
#define BLC_BW_AUTO_BLC6  			(BLC_BW_BASE+0x012) 			
#define BLC_BW_AUTO_BLC7  			(BLC_BW_BASE+0x014) 			
#define BLC_BW_AUTO_BLC8  			(BLC_BW_BASE+0x016) 			
#define BLC_BW_AUTO_BLC9  			(BLC_BW_BASE+0x018) 			
#define BLC_BW_AUTO_BLC10 			(BLC_BW_BASE+0x01A) 			
#define BLC_BW_AUTO_BLC11 			(BLC_BW_BASE+0x01C) 			
#define BLC_BW_AUTO_BLC12 			(BLC_BW_BASE+0x01E) 			
#define BLC_BW_AUTO_BLC13 			(BLC_BW_BASE+0x020) 			
#define BLC_BW_AUTO_BLC14 			(BLC_BW_BASE+0x022) 			
#define BLC_BW_AUTO_BLC15      		(BLC_BW_BASE+0x024)   

	

/********************************************************************************************
5.  Gamma
********************************************************************************************/
//Gamma(Color)
#define GAM_COLOR_BASE				(F_DEBUG_BASE+0x400) 
#define GAM_COLOR_ENABLE      		(GAM_COLOR_BASE+0x002) 
#define GAM_COLOR_TYPE	      			(GAM_COLOR_BASE+0x004) 
#define GAM_COLOR_TAB0  			(GAM_COLOR_BASE+0x006) 			
#define GAM_COLOR_TAB1 				(GAM_COLOR_BASE+0x008) 			
#define GAM_COLOR_TAB2  			(GAM_COLOR_BASE+0x00A) 			
#define GAM_COLOR_TAB3  			(GAM_COLOR_BASE+0x00C) 			
#define GAM_COLOR_TAB4  			(GAM_COLOR_BASE+0x00E) 			
#define GAM_COLOR_TAB5  			(GAM_COLOR_BASE+0x010) 			
#define GAM_COLOR_TAB6  			(GAM_COLOR_BASE+0x012) 			
#define GAM_COLOR_TAB7  			(GAM_COLOR_BASE+0x014) 			
#define GAM_COLOR_TAB8  			(GAM_COLOR_BASE+0x016) 			
#define GAM_COLOR_TAB9  			(GAM_COLOR_BASE+0x018) 	
#define GAM_COLOR_TAB10 			(GAM_COLOR_BASE+0x01A) 		
#define GAM_COLOR_TAB11 			(GAM_COLOR_BASE+0x01C) 			
#define GAM_COLOR_TAB12 			(GAM_COLOR_BASE+0x01E) 			
#define GAM_COLOR_TAB13 			(GAM_COLOR_BASE+0x020) 			
#define GAM_COLOR_TAB14 			(GAM_COLOR_BASE+0x022) 			
#define GAM_COLOR_TAB15       		(GAM_COLOR_BASE+0x024)    
#define GAM_COLOR_TAB16 			(GAM_COLOR_BASE+0x026) 			
#define GAM_COLOR_TAB17 			(GAM_COLOR_BASE+0x028) 			
#define GAM_COLOR_TAB18 			(GAM_COLOR_BASE+0x02A) 			
#define GAM_COLOR_TAB19 			(GAM_COLOR_BASE+0x02C) 	
#define GAM_COLOR_TAB20 			(GAM_COLOR_BASE+0x02E) 			
#define GAM_COLOR_TAB21 			(GAM_COLOR_BASE+0x030) 			
#define GAM_COLOR_TAB22 			(GAM_COLOR_BASE+0x032) 			
#define GAM_COLOR_TAB23 			(GAM_COLOR_BASE+0x034) 			
#define GAM_COLOR_TAB24 			(GAM_COLOR_BASE+0x036) 			
#define GAM_COLOR_TAB25       		(GAM_COLOR_BASE+0x038)    
#define GAM_COLOR_TAB26 			(GAM_COLOR_BASE+0x03A) 			
#define GAM_COLOR_TAB27 			(GAM_COLOR_BASE+0x03C) 			
#define GAM_COLOR_TAB28 			(GAM_COLOR_BASE+0x03E) 			
#define GAM_COLOR_TAB29 			(GAM_COLOR_BASE+0x040) 	
#define GAM_COLOR_TAB30 			(GAM_COLOR_BASE+0x042) 
#define GAM_COLOR_TAB31 			(GAM_COLOR_BASE+0x044) 
#define GAM_COLOR_TAB32 			(GAM_COLOR_BASE+0x046) 
#define GAM_COLOR_TAB33 			(GAM_COLOR_BASE+0x048) 
#define GAM_COLOR_TAB34 			(GAM_COLOR_BASE+0x04A) 
#define GAM_COLOR_TAB35       		(GAM_COLOR_BASE+0x04C) 
#define GAM_COLOR_TAB36 			(GAM_COLOR_BASE+0x04E) 
#define GAM_COLOR_TAB37 			(GAM_COLOR_BASE+0x050) 
#define GAM_COLOR_TAB38 			(GAM_COLOR_BASE+0x052) 
#define GAM_COLOR_TAB39 			(GAM_COLOR_BASE+0x054) 
#define GAM_COLOR_TAB40 			(GAM_COLOR_BASE+0x056) 
#define GAM_COLOR_TAB41 			(GAM_COLOR_BASE+0x058) 
#define GAM_COLOR_TAB42 			(GAM_COLOR_BASE+0x05A) 
#define GAM_COLOR_TAB43 			(GAM_COLOR_BASE+0x05C) 
#define GAM_COLOR_TAB44 			(GAM_COLOR_BASE+0x05E) 
#define GAM_COLOR_TAB45       		(GAM_COLOR_BASE+0x060) 
#define GAM_COLOR_TAB46 			(GAM_COLOR_BASE+0x062) 
#define GAM_COLOR_TAB47 			(GAM_COLOR_BASE+0x064) 
#define GAM_COLOR_TAB48 			(GAM_COLOR_BASE+0x066) 
#define GAM_COLOR_TAB49 			(GAM_COLOR_BASE+0x068) 
#define GAM_COLOR_TAB50 			(GAM_COLOR_BASE+0x06A) 
#define GAM_COLOR_TAB51 			(GAM_COLOR_BASE+0x06C) 
#define GAM_COLOR_TAB52 			(GAM_COLOR_BASE+0x06E) 
#define GAM_COLOR_TAB53 			(GAM_COLOR_BASE+0x070) 
#define GAM_COLOR_TAB54 			(GAM_COLOR_BASE+0x072) 
#define GAM_COLOR_TAB55       		(GAM_COLOR_BASE+0x074) 
#define GAM_COLOR_TAB56 			(GAM_COLOR_BASE+0x076) 
#define GAM_COLOR_TAB57 			(GAM_COLOR_BASE+0x078) 
#define GAM_COLOR_TAB58 			(GAM_COLOR_BASE+0x07A) 
#define GAM_COLOR_TAB59 			(GAM_COLOR_BASE+0x07C) 
#define GAM_COLOR_TAB60 			(GAM_COLOR_BASE+0x07E) 
#define GAM_COLOR_TAB61 			(GAM_COLOR_BASE+0x080) 
#define GAM_COLOR_TAB62 			(GAM_COLOR_BASE+0x082) 
#define GAM_COLOR_TAB63 			(GAM_COLOR_BASE+0x084) 
#define GAM_COLOR_TAB64 			(GAM_COLOR_BASE+0x086) 
#define GAM_COLOR_TAB65       		(GAM_COLOR_BASE+0x088) 
#define GAM_COLOR_TAB66 			(GAM_COLOR_BASE+0x08A) 
#define GAM_COLOR_TAB67 			(GAM_COLOR_BASE+0x08C) 
#define GAM_COLOR_TAB68 			(GAM_COLOR_BASE+0x08E) 
#define GAM_COLOR_TAB69 			(GAM_COLOR_BASE+0x090) 
#define GAM_COLOR_TAB70 			(GAM_COLOR_BASE+0x092) 
#define GAM_COLOR_TAB71 			(GAM_COLOR_BASE+0x094) 
#define GAM_COLOR_TAB72 			(GAM_COLOR_BASE+0x096) 
#define GAM_COLOR_TAB73 			(GAM_COLOR_BASE+0x098) 
#define GAM_COLOR_TAB74 			(GAM_COLOR_BASE+0x09A) 
#define GAM_COLOR_TAB75 			(GAM_COLOR_BASE+0x09C) 
#define GAM_COLOR_TAB76       		(GAM_COLOR_BASE+0x09E) 
#define GAM_COLOR_TAB77 			(GAM_COLOR_BASE+0x0A0) 
#define GAM_COLOR_TAB78 			(GAM_COLOR_BASE+0x0A2) 
#define GAM_COLOR_TAB79 			(GAM_COLOR_BASE+0x0A4) 
#define GAM_COLOR_TAB80 			(GAM_COLOR_BASE+0x0A6) 
#define GAM_COLOR_TAB81 			(GAM_COLOR_BASE+0x0A8) 
#define GAM_COLOR_TAB82 			(GAM_COLOR_BASE+0x0AA) 
#define GAM_COLOR_TAB83 			(GAM_COLOR_BASE+0x0AC) 
#define GAM_COLOR_TAB84 			(GAM_COLOR_BASE+0x0AE) 
#define GAM_COLOR_TAB85 			(GAM_COLOR_BASE+0x0B0) 
#define GAM_COLOR_TAB86       		(GAM_COLOR_BASE+0x0B2) 
#define GAM_COLOR_TAB87 			(GAM_COLOR_BASE+0x0B4) 
#define GAM_COLOR_TAB88 			(GAM_COLOR_BASE+0x0B6) 
#define GAM_COLOR_TAB89 			(GAM_COLOR_BASE+0x0B8) 
#define GAM_COLOR_TAB90 			(GAM_COLOR_BASE+0x0BA) 
#define GAM_COLOR_TAB91 			(GAM_COLOR_BASE+0x0BC) 
#define GAM_COLOR_TAB92 			(GAM_COLOR_BASE+0x0BE) 
#define GAM_COLOR_TAB93 			(GAM_COLOR_BASE+0x0C0) 
#define GAM_COLOR_TAB94 			(GAM_COLOR_BASE+0x0C2) 
#define GAM_COLOR_TAB95 			(GAM_COLOR_BASE+0x0C4) 
#define GAM_COLOR_TAB96 			(GAM_COLOR_BASE+0x0C6) 

//Gamma(BW)
#define GAM_BW_BASE			(F_DEBUG_BASE+0x4E0) 
#define GAM_BW_ENABLE      		(GAM_BW_BASE+0x002) 
#define GAM_BW_TYPE	      		(GAM_BW_BASE+0x004) 
#define GAM_BW_TAB0  			(GAM_BW_BASE+0x006) 			
#define GAM_BW_TAB1 			(GAM_BW_BASE+0x008) 			
#define GAM_BW_TAB2  			(GAM_BW_BASE+0x00A) 			
#define GAM_BW_TAB3  			(GAM_BW_BASE+0x00C) 			
#define GAM_BW_TAB4  			(GAM_BW_BASE+0x00E) 			
#define GAM_BW_TAB5  			(GAM_BW_BASE+0x010) 			
#define GAM_BW_TAB6  			(GAM_BW_BASE+0x012) 			
#define GAM_BW_TAB7  			(GAM_BW_BASE+0x014) 			
#define GAM_BW_TAB8  			(GAM_BW_BASE+0x016) 			
#define GAM_BW_TAB9  			(GAM_BW_BASE+0x018) 	
#define GAM_BW_TAB10 			(GAM_BW_BASE+0x01A) 		
#define GAM_BW_TAB11 			(GAM_BW_BASE+0x01C) 			
#define GAM_BW_TAB12 			(GAM_BW_BASE+0x01E) 			
#define GAM_BW_TAB13 			(GAM_BW_BASE+0x020) 			
#define GAM_BW_TAB14 			(GAM_BW_BASE+0x022) 			
#define GAM_BW_TAB15       		(GAM_BW_BASE+0x024)    
#define GAM_BW_TAB16 			(GAM_BW_BASE+0x026) 			
#define GAM_BW_TAB17 			(GAM_BW_BASE+0x028) 			
#define GAM_BW_TAB18 			(GAM_BW_BASE+0x02A) 			
#define GAM_BW_TAB19 			(GAM_BW_BASE+0x02C) 	
#define GAM_BW_TAB20 			(GAM_BW_BASE+0x02E) 			
#define GAM_BW_TAB21 			(GAM_BW_BASE+0x030) 			
#define GAM_BW_TAB22 			(GAM_BW_BASE+0x032) 			
#define GAM_BW_TAB23 			(GAM_BW_BASE+0x034) 			
#define GAM_BW_TAB24 			(GAM_BW_BASE+0x036) 			
#define GAM_BW_TAB25       		(GAM_BW_BASE+0x038)    
#define GAM_BW_TAB26 			(GAM_BW_BASE+0x03A) 			
#define GAM_BW_TAB27 			(GAM_BW_BASE+0x03C) 			
#define GAM_BW_TAB28 			(GAM_BW_BASE+0x03E) 			
#define GAM_BW_TAB29 			(GAM_BW_BASE+0x040) 	
#define GAM_BW_TAB30 			(GAM_BW_BASE+0x042) 
#define GAM_BW_TAB31 			(GAM_BW_BASE+0x044) 
#define GAM_BW_TAB32 			(GAM_BW_BASE+0x046) 
#define GAM_BW_TAB33 			(GAM_BW_BASE+0x048) 
#define GAM_BW_TAB34 			(GAM_BW_BASE+0x04A) 
#define GAM_BW_TAB35       		(GAM_BW_BASE+0x04C) 
#define GAM_BW_TAB36 			(GAM_BW_BASE+0x04E) 
#define GAM_BW_TAB37 			(GAM_BW_BASE+0x050) 
#define GAM_BW_TAB38 			(GAM_BW_BASE+0x052) 
#define GAM_BW_TAB39 			(GAM_BW_BASE+0x054) 
#define GAM_BW_TAB40 			(GAM_BW_BASE+0x056) 
#define GAM_BW_TAB41 			(GAM_BW_BASE+0x058) 
#define GAM_BW_TAB42 			(GAM_BW_BASE+0x05A) 
#define GAM_BW_TAB43 			(GAM_BW_BASE+0x05C) 
#define GAM_BW_TAB44 			(GAM_BW_BASE+0x05E) 
#define GAM_BW_TAB45       		(GAM_BW_BASE+0x060) 
#define GAM_BW_TAB46 			(GAM_BW_BASE+0x062) 
#define GAM_BW_TAB47 			(GAM_BW_BASE+0x064) 
#define GAM_BW_TAB48 			(GAM_BW_BASE+0x066) 
#define GAM_BW_TAB49 			(GAM_BW_BASE+0x068) 
#define GAM_BW_TAB50 			(GAM_BW_BASE+0x06A) 
#define GAM_BW_TAB51 			(GAM_BW_BASE+0x06C) 
#define GAM_BW_TAB52 			(GAM_BW_BASE+0x06E) 
#define GAM_BW_TAB53 			(GAM_BW_BASE+0x070) 
#define GAM_BW_TAB54 			(GAM_BW_BASE+0x072) 
#define GAM_BW_TAB55       		(GAM_BW_BASE+0x074) 
#define GAM_BW_TAB56 			(GAM_BW_BASE+0x076) 
#define GAM_BW_TAB57 			(GAM_BW_BASE+0x078) 
#define GAM_BW_TAB58 			(GAM_BW_BASE+0x07A) 
#define GAM_BW_TAB59 			(GAM_BW_BASE+0x07C) 
#define GAM_BW_TAB60 			(GAM_BW_BASE+0x07E) 
#define GAM_BW_TAB61 			(GAM_BW_BASE+0x080) 
#define GAM_BW_TAB62 			(GAM_BW_BASE+0x082) 
#define GAM_BW_TAB63 			(GAM_BW_BASE+0x084) 
#define GAM_BW_TAB64 			(GAM_BW_BASE+0x086) 
#define GAM_BW_TAB65       		(GAM_BW_BASE+0x088) 
#define GAM_BW_TAB66 			(GAM_BW_BASE+0x08A) 
#define GAM_BW_TAB67 			(GAM_BW_BASE+0x08C) 
#define GAM_BW_TAB68 			(GAM_BW_BASE+0x08E) 
#define GAM_BW_TAB69 			(GAM_BW_BASE+0x090) 
#define GAM_BW_TAB70 			(GAM_BW_BASE+0x092) 
#define GAM_BW_TAB71 			(GAM_BW_BASE+0x094) 
#define GAM_BW_TAB72 			(GAM_BW_BASE+0x096) 
#define GAM_BW_TAB73 			(GAM_BW_BASE+0x098) 
#define GAM_BW_TAB74 			(GAM_BW_BASE+0x09A) 
#define GAM_BW_TAB75 			(GAM_BW_BASE+0x09C) 
#define GAM_BW_TAB76       		(GAM_BW_BASE+0x09E) 
#define GAM_BW_TAB77 			(GAM_BW_BASE+0x0A0) 
#define GAM_BW_TAB78 			(GAM_BW_BASE+0x0A2) 
#define GAM_BW_TAB79 			(GAM_BW_BASE+0x0A4) 
#define GAM_BW_TAB80 			(GAM_BW_BASE+0x0A6) 
#define GAM_BW_TAB81 			(GAM_BW_BASE+0x0A8) 
#define GAM_BW_TAB82 			(GAM_BW_BASE+0x0AA) 
#define GAM_BW_TAB83 			(GAM_BW_BASE+0x0AC) 
#define GAM_BW_TAB84 			(GAM_BW_BASE+0x0AE) 
#define GAM_BW_TAB85 			(GAM_BW_BASE+0x0B0) 
#define GAM_BW_TAB86       		(GAM_BW_BASE+0x0B2) 
#define GAM_BW_TAB87 			(GAM_BW_BASE+0x0B4) 
#define GAM_BW_TAB88 			(GAM_BW_BASE+0x0B6) 
#define GAM_BW_TAB89 			(GAM_BW_BASE+0x0B8) 
#define GAM_BW_TAB90 			(GAM_BW_BASE+0x0BA) 
#define GAM_BW_TAB91 			(GAM_BW_BASE+0x0BC) 
#define GAM_BW_TAB92 			(GAM_BW_BASE+0x0BE) 
#define GAM_BW_TAB93 			(GAM_BW_BASE+0x0C0) 
#define GAM_BW_TAB94 			(GAM_BW_BASE+0x0C2) 
#define GAM_BW_TAB95 			(GAM_BW_BASE+0x0C4) 
#define GAM_BW_TAB96 			(GAM_BW_BASE+0x0C6) 


/********************************************************************************************
6.  CCM
********************************************************************************************/
#define F_CCM_BASE                     		(F_DEBUG_BASE+0xE00) 
#define F_CCM_BYPASS                   		(F_CCM_BASE+0x002)
#define F_CCM_OPTYPE	                  	(F_CCM_BASE+0x004)
#define F_CCM_MANUAL_R_OFST		(F_CCM_BASE+0x006)	
#define F_CCM_MANUAL_R_R			(F_CCM_BASE+0x008)	
#define F_CCM_MANUAL_R_G			(F_CCM_BASE+0x00A)	
#define F_CCM_MANUAL_R_B			(F_CCM_BASE+0x00C)	
#define F_CCM_MANUAL_G_OFST		(F_CCM_BASE+0x00E)	
#define F_CCM_MANUAL_G_R			(F_CCM_BASE+0x010)	
#define F_CCM_MANUAL_G_G			(F_CCM_BASE+0x012)	
#define F_CCM_MANUAL_G_B			(F_CCM_BASE+0x014)	
#define F_CCM_MANUAL_B_OFST		(F_CCM_BASE+0x016)	
#define F_CCM_MANUAL_B_R			(F_CCM_BASE+0x018)	
#define F_CCM_MANUAL_B_G			(F_CCM_BASE+0x01A)		
#define F_CCM_MANUAL_B_B			(F_CCM_BASE+0x01C)	

#define F_CCM_HIGH_CT				(F_CCM_BASE+0x020)	
#define F_CCM_AUTO1_R_OFST			(F_CCM_BASE+0x022)	
#define F_CCM_AUTO1_R_R                 	(F_CCM_BASE+0x024)
#define F_CCM_AUTO1_R_G                 	(F_CCM_BASE+0x026)
#define F_CCM_AUTO1_R_B                 	(F_CCM_BASE+0x028)
#define F_CCM_AUTO1_G_OFST         	(F_CCM_BASE+0x02A)
#define F_CCM_AUTO1_G_R                 	(F_CCM_BASE+0x02C)
#define F_CCM_AUTO1_G_G                 	(F_CCM_BASE+0x02E)
#define F_CCM_AUTO1_G_B                 	(F_CCM_BASE+0x030)
#define F_CCM_AUTO1_B_OFST    		(F_CCM_BASE+0x032)
#define F_CCM_AUTO1_B_R                 	(F_CCM_BASE+0x034)
#define F_CCM_AUTO1_B_G                 	(F_CCM_BASE+0x036)
#define F_CCM_AUTO1_B_B                 	(F_CCM_BASE+0x038)
                                    
#define F_CCM_MID_CT				(F_CCM_BASE+0x040)
#define F_CCM_AUTO2_R_OFST		(F_CCM_BASE+0x042)
#define F_CCM_AUTO2_R_R                 	(F_CCM_BASE+0x044)
#define F_CCM_AUTO2_R_G                 	(F_CCM_BASE+0x046)
#define F_CCM_AUTO2_R_B                 	(F_CCM_BASE+0x048)
#define F_CCM_AUTO2_G_OFST           	(F_CCM_BASE+0x04A)
#define F_CCM_AUTO2_G_R                 	(F_CCM_BASE+0x04C)
#define F_CCM_AUTO2_G_G                 	(F_CCM_BASE+0x04E)
#define F_CCM_AUTO2_G_B                 	(F_CCM_BASE+0x050)
#define F_CCM_AUTO2_B_OFST           	(F_CCM_BASE+0x052)
#define F_CCM_AUTO2_B_R                 	(F_CCM_BASE+0x054)
#define F_CCM_AUTO2_B_G                 	(F_CCM_BASE+0x056)
#define F_CCM_AUTO2_B_B                 	(F_CCM_BASE+0x058)                       
                                                               
#define F_CCM_LOW_CT				(F_CCM_BASE+0x060)                           
#define F_CCM_AUTO3_R_OFST		(F_CCM_BASE+0x062)                           
#define F_CCM_AUTO3_R_R                 	(F_CCM_BASE+0x064)                           
#define F_CCM_AUTO3_R_G                 	(F_CCM_BASE+0x066)                           
#define F_CCM_AUTO3_R_B                 	(F_CCM_BASE+0x068)                           
#define F_CCM_AUTO3_G_OFST           	(F_CCM_BASE+0x06A)                           
#define F_CCM_AUTO3_G_R                 	(F_CCM_BASE+0x06C)                           
#define F_CCM_AUTO3_G_G                 	(F_CCM_BASE+0x06E)                           
#define F_CCM_AUTO3_G_B                 	(F_CCM_BASE+0x070)                           
#define F_CCM_AUTO3_B_OFST           	(F_CCM_BASE+0x072)                           
#define F_CCM_AUTO3_B_R                 	(F_CCM_BASE+0x074)                           
#define F_CCM_AUTO3_B_G                 	(F_CCM_BASE+0x076)  
#define F_CCM_AUTO3_B_B                 	(F_CCM_BASE+0x078)  


/********************************************************************************************
7.  Chroma
********************************************************************************************/
#define F_CHROMA_BASE					(F_DEBUG_BASE+0x5C0)      
#define F_CHROMA_ENABLE                      	(F_CHROMA_BASE+0x002)
#define F_CHROMA_OFST_PP			       (F_CHROMA_BASE+0x004)
#define F_CHROMA_OFST_R			      	(F_CHROMA_BASE+0x006)
#define F_CHROMA_OFST_YE			       (F_CHROMA_BASE+0x008)
#define F_CHROMA_OFST_G			       (F_CHROMA_BASE+0x00A)
#define F_CHROMA_OFST_CY			       (F_CHROMA_BASE+0x00C)
#define F_CHROMA_OFST_B				(F_CHROMA_BASE+0x00E)
#define F_CHROMA_STH_PP				(F_CHROMA_BASE+0x014)
#define F_CHROMA_STH_R				(F_CHROMA_BASE+0x016)
#define F_CHROMA_STH_YE				(F_CHROMA_BASE+0x018)
#define F_CHROMA_STH_G				(F_CHROMA_BASE+0x01A)
#define F_CHROMA_STH_CY				(F_CHROMA_BASE+0x01C)
#define F_CHROMA_STH_B				(F_CHROMA_BASE+0x01E)



/********************************************************************************************
9.  AntiFalseColor
********************************************************************************************/
#define F_AFC_BASE					(F_DEBUG_BASE+0x5E0)	
#define F_AFC_ENABLE  				(F_AFC_BASE+0x002)
#define F_AFC_STH					(F_AFC_BASE+0x004)


/********************************************************************************************
10.  Saturation
********************************************************************************************/
#define F_SAT_BASE					(F_DEBUG_BASE+0x600)	   	
#define F_SAT_OPTYPE                     		(F_SAT_BASE+0x002)
#define F_SAT_MANUAL_SAT			(F_SAT_BASE+0x004)
#define F_SAT_AUTO_SAT0                   	(F_SAT_BASE+0x006)
#define F_SAT_AUTO_SAT1                   	(F_SAT_BASE+0x008)
#define F_SAT_AUTO_SAT2                   	(F_SAT_BASE+0x00A)
#define F_SAT_AUTO_SAT3                   	(F_SAT_BASE+0x00C)
#define F_SAT_AUTO_SAT4                   	(F_SAT_BASE+0x00E)
#define F_SAT_AUTO_SAT5                   	(F_SAT_BASE+0x010)
#define F_SAT_AUTO_SAT6                   	(F_SAT_BASE+0x012)
#define F_SAT_AUTO_SAT7                   	(F_SAT_BASE+0x014)
#define F_SAT_AUTO_SAT8                   	(F_SAT_BASE+0x016)
#define F_SAT_AUTO_SAT9                   	(F_SAT_BASE+0x018)
#define F_SAT_AUTO_SAT10                  	(F_SAT_BASE+0x01A)
#define F_SAT_AUTO_SAT11                  	(F_SAT_BASE+0x01C)
#define F_SAT_AUTO_SAT12                  	(F_SAT_BASE+0x01E)
#define F_SAT_AUTO_SAT13                  	(F_SAT_BASE+0x020)
#define F_SAT_AUTO_SAT14                  	(F_SAT_BASE+0x022)
#define F_SAT_AUTO_SAT15                  	(F_SAT_BASE+0x024)



/********************************************************************************************
11.other
********************************************************************************************/
#define F_OTHER_BASE					(F_DEBUG_BASE+0x640)
#define CONFIG_ENABLE				F_OTHER_BASE
//Gain limit
#define F_OTHER_GAIN50				(F_OTHER_BASE+0x002)
#define F_OTHER_GAIN100				(F_OTHER_BASE+0x004)
//Lum 
#define F_OTHER_LUM_DAY				(F_OTHER_BASE+0x006)
#define F_OTHER_LUM_NIT				(F_OTHER_BASE+0x008)
//EEShutter
#define F_OTHER_EE_OPN				(F_OTHER_BASE+0x00A)
#define F_OTHER_EE_CLS				(F_OTHER_BASE+0x00C)
//TDN
#define F_OTHER_TDN_DAY1				(F_OTHER_BASE+0x010)
#define F_OTHER_TDN_NIT1				(F_OTHER_BASE+0x012)
#define F_OTHER_TDN_DAY2				(F_OTHER_BASE+0x014)
#define F_OTHER_TDN_NIT2				(F_OTHER_BASE+0x016)
#define F_OTHER_TDN_DAY3				(F_OTHER_BASE+0x018)
#define F_OTHER_TDN_NIT3				(F_OTHER_BASE+0x01A)
#define F_OTHER_TDN_DAY4				(F_OTHER_BASE+0x01C)
#define F_OTHER_TDN_NIT4				(F_OTHER_BASE+0x01E)
#define F_OTHER_TDN_DAY5				(F_OTHER_BASE+0x020)
#define F_OTHER_TDN_NIT5				(F_OTHER_BASE+0x022)

#define F_OTHER_OSD_VERSION			(F_OTHER_BASE+0x030)
#define F_OTHER_OSDMENU_POS_X			(F_OTHER_BASE+0x032)
#define F_OTHER_OSDMENU_POS_Y			(F_OTHER_BASE+0x034)
#define F_OTHER_INFRARED_SWAP			(F_OTHER_BASE+0x036)

#define F_OTHER_YEAR					(F_OTHER_BASE+0x038)
#define F_OTHER_MON						(F_OTHER_BASE+0x03A)
#define F_OTHER_DAY						(F_OTHER_BASE+0x03C)
#define F_OTHER_CUSTOMER				(F_OTHER_BASE+0x03E)
/********************************************************************************************
12.AE
********************************************************************************************/
#define F_AE_BASE							(F_DEBUG_BASE+0x680)
#define AE_COLOR_T_MIN					(F_AE_BASE+0x002)
#define AE_COLOR_T_MAX					(F_AE_BASE+0x004)
#define AE_COLOR_AGAIN_MIN				(F_AE_BASE+0x006)
#define AE_COLOR_AGAIN_MAX				(F_AE_BASE+0x008)
#define AE_COLOR_DGAIN_MIN				(F_AE_BASE+0x00A)
#define AE_COLOR_DGAIN_MAX				(F_AE_BASE+0x00C)
#define AE_COLOR_ISPDGAIN_MIN			(F_AE_BASE+0x00E)
#define AE_COLOR_ISPDGAIN_MAX			(F_AE_BASE+0x010)
#define AE_COLOR_ALLGAIN_MAX1			(F_AE_BASE+0x012)
#define AE_COLOR_ALLGAIN_MAX2			(F_AE_BASE+0x014)
#define AE_COLOR_TARGET_NUM			(F_AE_BASE+0x020)
#define AE_COLOR_EXP0_H				(F_AE_BASE+0x022)
#define AE_COLOR_EXP0_L					(F_AE_BASE+0x024)
#define AE_COLOR_EXP1_H				(F_AE_BASE+0x026)
#define AE_COLOR_EXP1_L					(F_AE_BASE+0x028)
#define AE_COLOR_EXP2_H				(F_AE_BASE+0x02A)
#define AE_COLOR_EXP2_L					(F_AE_BASE+0x02C)
#define AE_COLOR_EXP3_H				(F_AE_BASE+0x02E)
#define AE_COLOR_EXP3_L					(F_AE_BASE+0x030)
#define AE_COLOR_LUMTGT0				(F_AE_BASE+0x032)
#define AE_COLOR_LUMTGT1				(F_AE_BASE+0x034)
#define AE_COLOR_LUMTGT2				(F_AE_BASE+0x036)
#define AE_COLOR_LUMTGT3				(F_AE_BASE+0x038)
#define F_GAMMA_BY_AGC					(F_AE_BASE+0x040)
#define F_GAMMA_THRESHOLD_1			(F_AE_BASE+0x042)
#define F_GAMMA_THRESHOLD_2			(F_AE_BASE+0x044)



#define AE_BW_T_MIN					 	(AE_COLOR_T_MIN+0x080)
#define AE_BW_T_MAX					(AE_COLOR_T_MAX+0x080)
#define AE_BW_AGAIN_MIN				(AE_COLOR_AGAIN_MIN+0x080)
#define AE_BW_AGAIN_MAX				(AE_COLOR_AGAIN_MAX+0x080)
#define AE_BW_DGAIN_MIN				(AE_COLOR_DGAIN_MIN+0x080)
#define AE_BW_DGAIN_MAX				(AE_COLOR_DGAIN_MAX+0x080)
#define AE_BW_ISPDGAIN_MIN				(AE_COLOR_ISPDGAIN_MIN+0x080)
#define AE_BW_ISPDGAIN_MAX				(AE_COLOR_ISPDGAIN_MAX+0x080)

// 13.CSC
#define F_CSC_CFG_BASE						(F_DEBUG_BASE+0x780)
#define F_CSC_COLOR_LUM					(F_CSC_CFG_BASE+0x000)	
#define F_CSC_COLOR_CON					(F_CSC_CFG_BASE+0x002)	
#define F_CSC_COLOR_AUTANCE				(F_CSC_CFG_BASE+0x004)	
#define F_CSC_COLOR_HUE       					(F_CSC_CFG_BASE+0x006)
#define F_CSC_COLOR_SAT       					(F_CSC_CFG_BASE+0x008)
#define F_CSC_COLOR_AUTO_CON0				(F_CSC_CFG_BASE+0x010)
#define F_CSC_COLOR_AUTO_CON1				(F_CSC_CFG_BASE+0x012)
#define F_CSC_COLOR_AUTO_CON2				(F_CSC_CFG_BASE+0x014)
#define F_CSC_COLOR_AUTO_CON3				(F_CSC_CFG_BASE+0x016)
#define F_CSC_COLOR_AUTO_CON4				(F_CSC_CFG_BASE+0x018)
#define F_CSC_COLOR_AUTO_CON5				(F_CSC_CFG_BASE+0x01A)
#define F_CSC_COLOR_AUTO_CON6				(F_CSC_CFG_BASE+0x01C)
#define F_CSC_COLOR_AUTO_CON7				(F_CSC_CFG_BASE+0x01E)
#define F_CSC_COLOR_AUTO_CON8				(F_CSC_CFG_BASE+0x020)
#define F_CSC_COLOR_AUTO_CON9				(F_CSC_CFG_BASE+0x022)
#define F_CSC_COLOR_AUTO_CON10			(F_CSC_CFG_BASE+0x024)
#define F_CSC_COLOR_AUTO_CON11			(F_CSC_CFG_BASE+0x026)
#define F_CSC_COLOR_AUTO_CON12			(F_CSC_CFG_BASE+0x028)
#define F_CSC_COLOR_AUTO_CON13			(F_CSC_CFG_BASE+0x02A)
#define F_CSC_COLOR_AUTO_CON14			(F_CSC_CFG_BASE+0x02C)
#define F_CSC_COLOR_AUTO_CON15			(F_CSC_CFG_BASE+0x02E)

#define F_CSC_BW_LUMCON					(F_CSC_COLOR_LUMCON+0x080)	
#define F_CSC_BW_AUTANCE					(F_CSC_COLOR_AUTANCE+0x080)	
#define F_CSC_BW_HUESAT       				(F_CSC_COLOR_HUESAT+0x080)
#define F_CSC_BW_AUTO_CON0				(F_CSC_COLOR_AUTO_CON0+0x080)
#define F_CSC_BW_AUTO_CON1				(F_CSC_COLOR_AUTO_CON1+0x080)
#define F_CSC_BW_AUTO_CON2				(F_CSC_COLOR_AUTO_CON2+0x080)
#define F_CSC_BW_AUTO_CON3				(F_CSC_COLOR_AUTO_CON3+0x080)
#define F_CSC_BW_AUTO_CON4				(F_CSC_COLOR_AUTO_CON4+0x080)
#define F_CSC_BW_AUTO_CON5				(F_CSC_COLOR_AUTO_CON5+0x080)
#define F_CSC_BW_AUTO_CON6				(F_CSC_COLOR_AUTO_CON6+0x080)
#define F_CSC_BW_AUTO_CON7				(F_CSC_COLOR_AUTO_CON7+0x080)
#define F_CSC_BW_AUTO_CON8				(F_CSC_COLOR_AUTO_CON8+0x080)
#define F_CSC_BW_AUTO_CON9				(F_CSC_COLOR_AUTO_CON9+0x080)
#define F_CSC_BW_AUTO_CON10			 	(F_CSC_COLOR_AUTO_CON10+0x080)
#define F_CSC_BW_AUTO_CON11				(F_CSC_COLOR_AUTO_CON11+0x080)
#define F_CSC_BW_AUTO_CON12				(F_CSC_COLOR_AUTO_CON12+0x080)
#define F_CSC_BW_AUTO_CON13				(F_CSC_COLOR_AUTO_CON13+0x080)
#define F_CSC_BW_AUTO_CON14			  	(F_CSC_COLOR_AUTO_CON14+0x080)
#define F_CSC_BW_AUTO_CON15			 	(F_CSC_COLOR_AUTO_CON15+0x080)

// YCNr
#define F_YCNR_BASE 							(F_DEBUG_BASE+0x900)
#define F_YCNR_COLOR_EN     					(F_YCNR_BASE+0x000)
#define F_YCNR_COLOR_OPTYPE  				(F_YCNR_BASE+0x002)
#define F_YCNR_COLOR_MAN_SMP				(F_YCNR_BASE+0x010)
#define F_YCNR_COLOR_MAN_NRKM1	    		(F_YCNR_BASE+0x012)
#define F_YCNR_COLOR_MAN_NRKH1	    		(F_YCNR_BASE+0x014)
#define F_YCNR_COLOR_MAN_NRKM2     			(F_YCNR_BASE+0x016)
#define F_YCNR_COLOR_MAN_NRKH2     			(F_YCNR_BASE+0x018)
#define F_YCNR_COLOR_MAN_SPKM1     			(F_YCNR_BASE+0x01A)
#define F_YCNR_COLOR_MAN_SPKH1     			(F_YCNR_BASE+0x01C)
#define F_YCNR_COLOR_MAN_SPKM2     			(F_YCNR_BASE+0x01E)
#define F_YCNR_COLOR_MAN_SPKH2     			(F_YCNR_BASE+0x020)
#define F_YCNR_COLOR_SMP_AUTO0     			(F_YCNR_BASE+0x030)
#define F_YCNR_COLOR_SMP_AUTO1     			(F_YCNR_BASE+0x032)
#define F_YCNR_COLOR_SMP_AUTO2     			(F_YCNR_BASE+0x034)
#define F_YCNR_COLOR_SMP_AUTO3     			(F_YCNR_BASE+0x036)
#define F_YCNR_COLOR_SMP_AUTO4     			(F_YCNR_BASE+0x038)
#define F_YCNR_COLOR_SMP_AUTO5     			(F_YCNR_BASE+0x03A)
#define F_YCNR_COLOR_SMP_AUTO6     			(F_YCNR_BASE+0x03C)
#define F_YCNR_COLOR_SMP_AUTO7     			(F_YCNR_BASE+0x03E)
#define F_YCNR_COLOR_SMP_AUTO8     			(F_YCNR_BASE+0x040)
#define F_YCNR_COLOR_SMP_AUTO9     			(F_YCNR_BASE+0x042)
#define F_YCNR_COLOR_SMP_AUTO10    			(F_YCNR_BASE+0x044)
#define F_YCNR_COLOR_SMP_AUTO11    			(F_YCNR_BASE+0x046)
#define F_YCNR_COLOR_SMP_AUTO12    			(F_YCNR_BASE+0x048)
#define F_YCNR_COLOR_SMP_AUTO13    			(F_YCNR_BASE+0x04A)
#define F_YCNR_COLOR_SMP_AUTO14    			(F_YCNR_BASE+0x04C)
#define F_YCNR_COLOR_SMP_AUTO15    			(F_YCNR_BASE+0x04E)
#define F_YCNR_COLOR_NRKM1_AUTO0   		(F_YCNR_BASE+0x050)
#define F_YCNR_COLOR_NRKM1_AUTO1   		(F_YCNR_BASE+0x052)
#define F_YCNR_COLOR_NRKM1_AUTO2   		(F_YCNR_BASE+0x054)
#define F_YCNR_COLOR_NRKM1_AUTO3   		(F_YCNR_BASE+0x056)
#define F_YCNR_COLOR_NRKM1_AUTO4   		(F_YCNR_BASE+0x058)
#define F_YCNR_COLOR_NRKM1_AUTO5   		(F_YCNR_BASE+0x05A)
#define F_YCNR_COLOR_NRKM1_AUTO6   		(F_YCNR_BASE+0x05C)
#define F_YCNR_COLOR_NRKM1_AUTO7   		(F_YCNR_BASE+0x05E)
#define F_YCNR_COLOR_NRKM1_AUTO8   		(F_YCNR_BASE+0x060)
#define F_YCNR_COLOR_NRKM1_AUTO9   		(F_YCNR_BASE+0x062)
#define F_YCNR_COLOR_NRKM1_AUTO10  		(F_YCNR_BASE+0x064)
#define F_YCNR_COLOR_NRKM1_AUTO11  		(F_YCNR_BASE+0x066)
#define F_YCNR_COLOR_NRKM1_AUTO12  		(F_YCNR_BASE+0x068)
#define F_YCNR_COLOR_NRKM1_AUTO13  		(F_YCNR_BASE+0x06A)
#define F_YCNR_COLOR_NRKM1_AUTO14  		(F_YCNR_BASE+0x06C)
#define F_YCNR_COLOR_NRKM1_AUTO15  		(F_YCNR_BASE+0x06E)
#define F_YCNR_COLOR_NRKH1_AUTO0   		(F_YCNR_BASE+0x070)
#define F_YCNR_COLOR_NRKH1_AUTO1	  		(F_YCNR_BASE+0x072)
#define F_YCNR_COLOR_NRKH1_AUTO2	  		(F_YCNR_BASE+0x074)
#define F_YCNR_COLOR_NRKH1_AUTO3   		(F_YCNR_BASE+0x076)
#define F_YCNR_COLOR_NRKH1_AUTO4   		(F_YCNR_BASE+0x078)
#define F_YCNR_COLOR_NRKH1_AUTO5   		(F_YCNR_BASE+0x07A)
#define F_YCNR_COLOR_NRKH1_AUTO6   		(F_YCNR_BASE+0x07C)
#define F_YCNR_COLOR_NRKH1_AUTO7   		(F_YCNR_BASE+0x07E)
#define F_YCNR_COLOR_NRKH1_AUTO8   		(F_YCNR_BASE+0x080)
#define F_YCNR_COLOR_NRKH1_AUTO9   		(F_YCNR_BASE+0x082)
#define F_YCNR_COLOR_NRKH1_AUTO10  		(F_YCNR_BASE+0x084)
#define F_YCNR_COLOR_NRKH1_AUTO11  		(F_YCNR_BASE+0x086)
#define F_YCNR_COLOR_NRKH1_AUTO12  		(F_YCNR_BASE+0x088)
#define F_YCNR_COLOR_NRKH1_AUTO13  		(F_YCNR_BASE+0x08A)
#define F_YCNR_COLOR_NRKH1_AUTO14  		(F_YCNR_BASE+0x08C)
#define F_YCNR_COLOR_NRKH1_AUTO15			(F_YCNR_BASE+0x08E)
#define F_YCNR_COLOR_NRKM2_AUTO0   		(F_YCNR_BASE+0x090)
#define F_YCNR_COLOR_NRKM2_AUTO1	  		(F_YCNR_BASE+0x092)
#define F_YCNR_COLOR_NRKM2_AUTO2	  		(F_YCNR_BASE+0x094)
#define F_YCNR_COLOR_NRKM2_AUTO3   		(F_YCNR_BASE+0x096)
#define F_YCNR_COLOR_NRKM2_AUTO4   		(F_YCNR_BASE+0x098)
#define F_YCNR_COLOR_NRKM2_AUTO5   		(F_YCNR_BASE+0x09A)
#define F_YCNR_COLOR_NRKM2_AUTO6   		(F_YCNR_BASE+0x09C)
#define F_YCNR_COLOR_NRKM2_AUTO7   		(F_YCNR_BASE+0x09E)
#define F_YCNR_COLOR_NRKM2_AUTO8   		(F_YCNR_BASE+0x0A0)
#define F_YCNR_COLOR_NRKM2_AUTO9   		(F_YCNR_BASE+0x0A2)
#define F_YCNR_COLOR_NRKM2_AUTO10  		(F_YCNR_BASE+0x0A4)
#define F_YCNR_COLOR_NRKM2_AUTO11  		(F_YCNR_BASE+0x0A6)
#define F_YCNR_COLOR_NRKM2_AUTO12  		(F_YCNR_BASE+0x0A8)
#define F_YCNR_COLOR_NRKM2_AUTO13  		(F_YCNR_BASE+0x0AA)
#define F_YCNR_COLOR_NRKM2_AUTO14  		(F_YCNR_BASE+0x0AC)
#define F_YCNR_COLOR_NRKM2_AUTO15  		(F_YCNR_BASE+0x0AE)
#define F_YCNR_COLOR_NRKH2_AUTO0   		(F_YCNR_BASE+0x0B0)
#define F_YCNR_COLOR_NRKH2_AUTO1	  		(F_YCNR_BASE+0x0B2)
#define F_YCNR_COLOR_NRKH2_AUTO2	  		(F_YCNR_BASE+0x0B4)
#define F_YCNR_COLOR_NRKH2_AUTO3   		(F_YCNR_BASE+0x0B6)
#define F_YCNR_COLOR_NRKH2_AUTO4   		(F_YCNR_BASE+0x0B8)
#define F_YCNR_COLOR_NRKH2_AUTO5   		(F_YCNR_BASE+0x0BA)
#define F_YCNR_COLOR_NRKH2_AUTO6   		(F_YCNR_BASE+0x0BC)
#define F_YCNR_COLOR_NRKH2_AUTO7   		(F_YCNR_BASE+0x0BE)
#define F_YCNR_COLOR_NRKH2_AUTO8   		(F_YCNR_BASE+0x0C0)
#define F_YCNR_COLOR_NRKH2_AUTO9   		(F_YCNR_BASE+0x0C2)
#define F_YCNR_COLOR_NRKH2_AUTO10  		(F_YCNR_BASE+0x0C4)
#define F_YCNR_COLOR_NRKH2_AUTO11  		(F_YCNR_BASE+0x0C6)
#define F_YCNR_COLOR_NRKH2_AUTO12  		(F_YCNR_BASE+0x0C8)
#define F_YCNR_COLOR_NRKH2_AUTO13  		(F_YCNR_BASE+0x0CA)
#define F_YCNR_COLOR_NRKH2_AUTO14			(F_YCNR_BASE+0x0CC)
#define F_YCNR_COLOR_NRKH2_AUTO15			(F_YCNR_BASE+0x0CE)
#define F_YCNR_COLOR_SPKM1_AUTO0			(F_YCNR_BASE+0x0D0)
#define F_YCNR_COLOR_SPKM1_AUTO1			(F_YCNR_BASE+0x0D2)
#define F_YCNR_COLOR_SPKM1_AUTO2			(F_YCNR_BASE+0x0D4)
#define F_YCNR_COLOR_SPKM1_AUTO3			(F_YCNR_BASE+0x0D6)
#define F_YCNR_COLOR_SPKM1_AUTO4			(F_YCNR_BASE+0x0D8)
#define F_YCNR_COLOR_SPKM1_AUTO5			(F_YCNR_BASE+0x0DA)
#define F_YCNR_COLOR_SPKM1_AUTO6			(F_YCNR_BASE+0x0DC)
#define F_YCNR_COLOR_SPKM1_AUTO7			(F_YCNR_BASE+0x0DE)
#define F_YCNR_COLOR_SPKM1_AUTO8			(F_YCNR_BASE+0x0E0)
#define F_YCNR_COLOR_SPKM1_AUTO9			(F_YCNR_BASE+0x0E2)
#define F_YCNR_COLOR_SPKM1_AUTO10			(F_YCNR_BASE+0x0E4)
#define F_YCNR_COLOR_SPKM1_AUTO11			(F_YCNR_BASE+0x0E6)
#define F_YCNR_COLOR_SPKM1_AUTO12			(F_YCNR_BASE+0x0E8)
#define F_YCNR_COLOR_SPKM1_AUTO13			(F_YCNR_BASE+0x0EA)
#define F_YCNR_COLOR_SPKM1_AUTO14			(F_YCNR_BASE+0x0EC)
#define F_YCNR_COLOR_SPKM1_AUTO15			(F_YCNR_BASE+0x0EE)
#define F_YCNR_COLOR_SPKH1_AUTO0			(F_YCNR_BASE+0x0F0)
#define F_YCNR_COLOR_SPKH1_AUTO1			(F_YCNR_BASE+0x0F2)
#define F_YCNR_COLOR_SPKH1_AUTO2			(F_YCNR_BASE+0x0F4)
#define F_YCNR_COLOR_SPKH1_AUTO3			(F_YCNR_BASE+0x0F6)
#define F_YCNR_COLOR_SPKH1_AUTO4			(F_YCNR_BASE+0x0F8)
#define F_YCNR_COLOR_SPKH1_AUTO5			(F_YCNR_BASE+0x0FA)
#define F_YCNR_COLOR_SPKH1_AUTO6			(F_YCNR_BASE+0x0FC)
#define F_YCNR_COLOR_SPKH1_AUTO7			(F_YCNR_BASE+0x0FE)
#define F_YCNR_COLOR_SPKH1_AUTO8			(F_YCNR_BASE+0x100)
#define F_YCNR_COLOR_SPKH1_AUTO9			(F_YCNR_BASE+0x102)
#define F_YCNR_COLOR_SPKH1_AUTO10			(F_YCNR_BASE+0x104)
#define F_YCNR_COLOR_SPKH1_AUTO11			(F_YCNR_BASE+0x106)
#define F_YCNR_COLOR_SPKH1_AUTO12			(F_YCNR_BASE+0x108)
#define F_YCNR_COLOR_SPKH1_AUTO13			(F_YCNR_BASE+0x10A)
#define F_YCNR_COLOR_SPKH1_AUTO14			(F_YCNR_BASE+0x10C)
#define F_YCNR_COLOR_SPKH1_AUTO15			(F_YCNR_BASE+0x10E)
#define F_YCNR_COLOR_SPKM2_AUTO0			(F_YCNR_BASE+0x110)
#define F_YCNR_COLOR_SPKM2_AUTO1			(F_YCNR_BASE+0x112)
#define F_YCNR_COLOR_SPKM2_AUTO2			(F_YCNR_BASE+0x114)
#define F_YCNR_COLOR_SPKM2_AUTO3			(F_YCNR_BASE+0x116)
#define F_YCNR_COLOR_SPKM2_AUTO4			(F_YCNR_BASE+0x118)
#define F_YCNR_COLOR_SPKM2_AUTO5			(F_YCNR_BASE+0x11A)
#define F_YCNR_COLOR_SPKM2_AUTO6			(F_YCNR_BASE+0x11C)
#define F_YCNR_COLOR_SPKM2_AUTO7			(F_YCNR_BASE+0x11E)
#define F_YCNR_COLOR_SPKM2_AUTO8			(F_YCNR_BASE+0x120)
#define F_YCNR_COLOR_SPKM2_AUTO9			(F_YCNR_BASE+0x122)
#define F_YCNR_COLOR_SPKM2_AUTO10			(F_YCNR_BASE+0x124)
#define F_YCNR_COLOR_SPKM2_AUTO11			(F_YCNR_BASE+0x126)
#define F_YCNR_COLOR_SPKM2_AUTO12			(F_YCNR_BASE+0x128)
#define F_YCNR_COLOR_SPKM2_AUTO13			(F_YCNR_BASE+0x12A)
#define F_YCNR_COLOR_SPKM2_AUTO14			(F_YCNR_BASE+0x12C)
#define F_YCNR_COLOR_SPKM2_AUTO15			(F_YCNR_BASE+0x12E)
#define F_YCNR_COLOR_SPKH2_AUTO0			(F_YCNR_BASE+0x130)
#define F_YCNR_COLOR_SPKH2_AUTO1			(F_YCNR_BASE+0x132)
#define F_YCNR_COLOR_SPKH2_AUTO2			(F_YCNR_BASE+0x134)
#define F_YCNR_COLOR_SPKH2_AUTO3			(F_YCNR_BASE+0x136)
#define F_YCNR_COLOR_SPKH2_AUTO4			(F_YCNR_BASE+0x138)
#define F_YCNR_COLOR_SPKH2_AUTO5			(F_YCNR_BASE+0x13A)
#define F_YCNR_COLOR_SPKH2_AUTO6			(F_YCNR_BASE+0x13C)
#define F_YCNR_COLOR_SPKH2_AUTO7			(F_YCNR_BASE+0x13E)
#define F_YCNR_COLOR_SPKH2_AUTO8			(F_YCNR_BASE+0x140)
#define F_YCNR_COLOR_SPKH2_AUTO9			(F_YCNR_BASE+0x142)
#define F_YCNR_COLOR_SPKH2_AUTO10			(F_YCNR_BASE+0x144)
#define F_YCNR_COLOR_SPKH2_AUTO11			(F_YCNR_BASE+0x146)
#define F_YCNR_COLOR_SPKH2_AUTO12			(F_YCNR_BASE+0x148)
#define F_YCNR_COLOR_SPKH2_AUTO13			(F_YCNR_BASE+0x14A)
#define F_YCNR_COLOR_SPKH2_AUTO14			(F_YCNR_BASE+0x14C)
#define F_YCNR_COLOR_SPKH2_AUTO15			(F_YCNR_BASE+0x14E)

// VENC TX
#define F_VENCTX_BASE 						(F_DEBUG_BASE+0xDD0)
#define F_VENCTX_EN     						(F_VENCTX_BASE+0x000)
#define F_VENCTX_TESTMODE     				(F_VENCTX_BASE+0x002)
#define F_VENCTX_BLANKVAL_PAL    			(F_VENCTX_BASE+0x004)
#define F_VENCTX_SYNCVAL_PAL     			(F_VENCTX_BASE+0x006)
#define F_VENCTX_CSYNCVAL_PAL     			(F_VENCTX_BASE+0x008)
#define F_VENCTX_SUBCARRIER_H_PAL			(F_VENCTX_BASE+0x00A)
#define F_VENCTX_SUBCARRIER_L_PAL			(F_VENCTX_BASE+0x00C)
#define F_VENCTX_YCGAIN_H_PAL				(F_VENCTX_BASE+0x00E)
#define F_VENCTX_YCGAIN_L_PAL				(F_VENCTX_BASE+0x010)

#define F_VENCTX_BLANKVAL_NTSC    			(F_VENCTX_BASE+0x014)
#define F_VENCTX_SYNCVAL_NTSC     			(F_VENCTX_BASE+0x016)
#define F_VENCTX_CSYNCVAL_NTSC     			(F_VENCTX_BASE+0x018)
#define F_VENCTX_SUBCARRIER_H_NTSC		(F_VENCTX_BASE+0x01A)
#define F_VENCTX_SUBCARRIER_L_NTSC		(F_VENCTX_BASE+0x01C)
#define F_VENCTX_YCGAIN_H_NTSC				(F_VENCTX_BASE+0x01E)
#define F_VENCTX_YCGAIN_L_NTSC				(F_VENCTX_BASE+0x020)


// Awb
#define F_AWB_BASE				(F_DEBUG_BASE+0xD00)
#define F_AWB_BYPASS			(F_AWB_BASE+0x000)
#define F_AWB_OPTYPE			(F_AWB_BASE+0x002)
#define F_AWB_MAN_RGAIN		(F_AWB_BASE+0x004)
#define F_AWB_MAN_GGAIN		(F_AWB_BASE+0x006)
#define F_AWB_MAN_BGAIN		(F_AWB_BASE+0x008)
#define F_AWB_MG_OFST			(F_AWB_BASE+0x010)
#define F_AWB_RB_OFST			(F_AWB_BASE+0x012)
#define F_AWB_R_OFST			(F_AWB_BASE+0x014)
#define F_AWB_B_OFST			(F_AWB_BASE+0x016)
#define F_AWB_SPEEDTOH			(F_AWB_BASE+0x018)
#define F_AWB_SPEEDTOL			(F_AWB_BASE+0x01A)
#define F_AWB_CTMAX			(F_AWB_BASE+0x01C)
#define F_AWB_CTMIN				(F_AWB_BASE+0x01E)
#define F_AWB_CAL_A0			(F_AWB_BASE+0x030)
#define F_AWB_CAL_A1			(F_AWB_BASE+0x032)
#define F_AWB_CAL_A2			(F_AWB_BASE+0x034)
#define F_AWB_CAL_A3			(F_AWB_BASE+0x036)
#define F_AWB_CAL_A4			(F_AWB_BASE+0x038)
#define F_AWB_CAL_A5			(F_AWB_BASE+0x03A)
#define F_AWB_CAL_A6			(F_AWB_BASE+0x03C)
#define F_AWB_CAL_A7			(F_AWB_BASE+0x03E)
#define F_AWB_CAL_B0			(F_AWB_BASE+0x040)
#define F_AWB_CAL_B1			(F_AWB_BASE+0x042)
#define F_AWB_CAL_B2			(F_AWB_BASE+0x044)
#define F_AWB_CAL_B3			(F_AWB_BASE+0x046)
#define F_AWB_CAL_B4			(F_AWB_BASE+0x048)
#define F_AWB_CAL_B5			(F_AWB_BASE+0x04A)
#define F_AWB_CAL_B6			(F_AWB_BASE+0x04C)
#define F_AWB_CAL_B7			(F_AWB_BASE+0x04E)
#define F_AWB_CAL_C0			(F_AWB_BASE+0x050)
#define F_AWB_CAL_C1			(F_AWB_BASE+0x052)
#define F_AWB_CAL_C2			(F_AWB_BASE+0x054)
#define F_AWB_CAL_C3			(F_AWB_BASE+0x056)
#define F_AWB_CAL_C4			(F_AWB_BASE+0x058)
#define F_AWB_CAL_C5			(F_AWB_BASE+0x05A)
#define F_AWB_CAL_C6			(F_AWB_BASE+0x05C)
#define F_AWB_CAL_C7			(F_AWB_BASE+0x05E)
#define F_AWB_KEY				(F_AWB_BASE+0x060)
#define F_AWB_INITX				(F_AWB_BASE+0x062)
#define F_AWB_INITY				(F_AWB_BASE+0x064)
#define F_AWB_DISMIN			(F_AWB_BASE+0x066)
#define F_AWB_DISMAX			(F_AWB_BASE+0x068)
#define F_AWB_DIS_0				(F_AWB_BASE+0x070)
#define F_AWB_DIS_1				(F_AWB_BASE+0x072)
#define F_AWB_DIS_2				(F_AWB_BASE+0x074)
#define F_AWB_DIS_3				(F_AWB_BASE+0x076)
#define F_AWB_DIS_4				(F_AWB_BASE+0x078)
#define F_AWB_DIS_5				(F_AWB_BASE+0x07A)
#define F_AWB_DIS_6				(F_AWB_BASE+0x07C)
#define F_AWB_DIS_7				(F_AWB_BASE+0x07E)
#define F_AWB_DIS_8				(F_AWB_BASE+0x080)
#define F_AWB_DIS_9				(F_AWB_BASE+0x082)
#define F_AWB_DIS_10			(F_AWB_BASE+0x084)
#define F_AWB_DIS_11			(F_AWB_BASE+0x086)
#define F_AWB_DIS_12			(F_AWB_BASE+0x088)
#define F_AWB_DIS_13			(F_AWB_BASE+0x08A)
#define F_AWB_DIS_14			(F_AWB_BASE+0x08C)
#define F_AWB_DIS_15			(F_AWB_BASE+0x08E)
#define F_AWB_VAL_0				(F_AWB_BASE+0x090)
#define F_AWB_VAL_1				(F_AWB_BASE+0x092)
#define F_AWB_VAL_2				(F_AWB_BASE+0x094)
#define F_AWB_VAL_3				(F_AWB_BASE+0x096)
#define F_AWB_VAL_4				(F_AWB_BASE+0x098)
#define F_AWB_VAL_5				(F_AWB_BASE+0x09A)
#define F_AWB_VAL_6				(F_AWB_BASE+0x09C)
#define F_AWB_VAL_7				(F_AWB_BASE+0x09E)
#define F_AWB_VAL_8				(F_AWB_BASE+0x0A0)
#define F_AWB_VAL_9				(F_AWB_BASE+0x0A2)
#define F_AWB_VAL_10			(F_AWB_BASE+0x0A4)
#define F_AWB_VAL_11			(F_AWB_BASE+0x0A6)
#define F_AWB_VAL_12			(F_AWB_BASE+0x0A8)
#define F_AWB_VAL_13			(F_AWB_BASE+0x0AA)
#define F_AWB_VAL_14			(F_AWB_BASE+0x0AC)
#define F_AWB_VAL_15			(F_AWB_BASE+0x0AE)
#define F_AWB_INITGAINR			(F_AWB_BASE+0x0B0)
#define F_AWB_INITGAING			(F_AWB_BASE+0x0B2)
#define F_AWB_INITGAINB			(F_AWB_BASE+0x0B4)
#define F_AWB_RSV				(F_AWB_BASE+0x0B6)

/********************************************************************************************
14.MENU
********************************************************************************************/
#define F_MENU_BASE				(F_DEBUG_BASE+0x4000)  
#define F_MENU_ENABLE				(F_MENU_BASE+0x000)	
#define F_MENU_EXP_MODE			(F_MENU_BASE+0x002)	
#define F_MENU_DNC_MODE			(F_MENU_BASE+0x004) 
#define F_MENU_BLC_EN	      			(F_MENU_BASE+0x006) 
#define F_MENU_AE_TGT		    		(F_MENU_BASE+0x008) 
#define F_MENU_DNC_THR			(F_MENU_BASE+0x00A)	
#define F_MENU_WDR_STH			(F_MENU_BASE+0x00C)	
#define F_MENU_IMG_STYLE    		(F_MENU_BASE+0x00E) 
#define F_MENU_AGC_EN				(F_MENU_BASE+0x010) 
#define F_MENU_AGC_MAX		  	(F_MENU_BASE+0x012) 
#define F_MENU_NRLVL_COL    		(F_MENU_BASE+0x014) 
#define F_MENU_NRLVL_BW     		(F_MENU_BASE+0x016) 
#define F_MENU_IRCUTMODE			(F_MENU_BASE+0x018) 
#define F_MENU_WB_RB        			(F_MENU_BASE+0x01A) 
#define F_MENU_WB_GM      			(F_MENU_BASE+0x01C) 
#define F_MENU_MIRROR				(F_MENU_BASE+0x01E) 
#define F_MENU_FLIP				(F_MENU_BASE+0x020) 
#define F_MENU_ANTIFLICKER		(F_MENU_BASE+0x022) 
#define F_MENU_IRCUTSWAP			(F_MENU_BASE+0x024) 
#define F_MENU_BRIGHTNESS		(F_MENU_BASE+0x026) 
#define F_MENU_CONTRAST			(F_MENU_BASE+0x028) 
#define F_MENU_SATURATION		(F_MENU_BASE+0x02A) 
#define F_MENU_HUE				(F_MENU_BASE+0x02C) 
#define F_MENU_ACUTANCE     		(F_MENU_BASE+0x02E) 
#define F_MENU_SAWTOOTH			(F_MENU_BASE+0x030) 
#define F_MENU_ANTIFC	      			(F_MENU_BASE+0x032) 
#define F_MENU_BW_BURST			(F_MENU_BASE+0x034) 
#define F_MENU_VSTD_TYPE		(F_MENU_BASE+0x036)	
#define F_MENU_VENC_TYPE		(F_MENU_BASE+0x038)	
#define F_MENU_RSLT_TYPE		(F_MENU_BASE+0x03A)	
#define F_MENU_ESHUTTER			(F_MENU_BASE+0x03C)	
#define F_MENU_HLC				(F_MENU_BASE+0x03E)	

#define F_MENU_CFGUSE_OFST		(0x1000)

//13 SBPC FPN Init data store
#define SBPC_DATA_BASE		(F_DEBUG_BASE+0x6000) //1.5KB
#define FPN_DATA_BASE		(SBPC_DATA_BASE+0x600)//5.25KB
#define SBPC_FPN_DATA_OFST		(0x2000)

#endif
