//
//  "$Id: MotionDetect.h 4 2009-06-11 13:01:43Z liwj $"
//
//  Copyright (c)2008-2008, ZheJiang JuFeng Technology Stock CO.LTD.
//  All Rights Reserved.
//
//	Description:	
//	Revisions:		Year-Month-Day  SVN-Author  Modification
//

#ifndef __PAL_MOTIONDETECT_H__
#define __PAL_MOTIONDETECT_H__

#ifdef __cplusplus
extern "C" {
#endif

/// \defgroup MotionDetectAPI API Motion Detect
/// ȵĶ̬ӿڡ
///	\n ͼ:
/// \code
///    ============================
///                  |
///         *MotionDetectGetCaps
///                  |
///          MotionDetectCreate
///     +------------|
///     |   MotionDetectGetState
///     | MotionDetectSetParameter
///     |   MotionDetectGetResult
///     |   MotionDetectShowHint
///     +------------|
///         MotionDetectDestory
///                  |
///    ============================
/// \endcode
/// @{

/// ̬
typedef struct MOTION_DETECT_PARAM
{
	/// ̬жȵ
	int		iLevel;

	/// ̬ݵÿһλӦһ飬1ʾҪڸ鶯
	/// ̬⣬0ʾҪڸ鶯̬⡣ÿһһunsigned intʾߵ
	/// ӦλϵµжӦ±017ֵ֧֮Ӧ
	/// λЧ
	unsigned int	win[18];

	/// ȵľֵ
	unsigned char	sensitiveness;

	/// ֡
	unsigned char	fieldinterval;

	/// ʹܿأǷʹܣΪ1ʾʹܣΪ0ʱʾãԡ
	int		enable;
}MOTION_DETECT_PARAM;

/// ̬
typedef struct MOTION_DETECT_RESULT
{
	/// ж̬ⷢݵÿһλӦһ飬1ʾڸ
	/// ̬ɹ0ʾ鶯̬ʧܡÿһһunsigned intʾ
	/// ĿλϵµжӦ±017ֵ֧֮Ӧ
	/// λЧ
	unsigned int	win[18];
}MOTION_DETECT_RESULT;

/// Ƶ̬Խṹ
typedef struct MOTION_DETECT_CAPS
{
	unsigned int Enabled;			///< 1ʾֶ֧̬⣬0ʾֶ֧̬⡣
	unsigned int GridLines;		///< ̬Ҫֳɵ
	unsigned int GridRows;			///< ̬Ҫֳɵ
	unsigned char  Result;			///< Ƿܵõÿļ
	unsigned char  Hint;				///< Ƿڼɹʱʾ
}MOTION_DETECT_CAPS;


/// ̬豸
/// 
/// \param 
/// \retval <0 ʧ
/// \retval 0 ɹ
int MotionDetectCreate(void);


/// ٶ̬豸
/// 
/// \param 
/// \retval <0 ʧ
/// \retval 0 ٳɹ
int MotionDetectDestory(void);


/// ִж̬⡣ء
/// 
/// \param [out] pData ָһunsigned intֵָ룬unsigned intֵǸͨƽ״̬
///        롣ͨڵλͨڸλߵƽ1͵ƽ0ڵͨ
///        0
/// \retval 0  ɹ
/// \retval <0  ʧ
int MotionDetectGetState(unsigned int* pData);


/// ̬Ⲷϸ
/// 
/// \param [in] channel ͨš
/// \param [in] pResult ָ̬ṹMOTION_DETECT_RESULTָ롣
/// \retval 0  óɹ
/// \retval <0  ʧ
int MotionDetectGetResult(int channel, MOTION_DETECT_RESULT *pResult);


/// Ƿڶ̬ɹʾ
/// 
/// \param [in] channel ͨš
/// \param [in] enable Ϊ1ʾʾΪ0ʱʾʾ
/// \retval 0  óɹ
/// \retval <0  ʧ
int MotionDetectShowHint(int channel, int enable);


/// ִж̬⡣ء
/// 
/// \param [in] channel ͨš
/// \param [in] pParam ָ̬ṹMOTION_DETECT_PARAMָ롣
/// \retval 0  óɹ
/// \retval <0  ʧ
int MotionDetectSetParameter(int channel, MOTION_DETECT_PARAM *pParam);


/// õֵ̬֧ԡ
/// 
/// \param [out] pCaps ָ̬ԽṹMOTION_DETECT_CAPSָ롣
/// \retval 0  ȡɹ
/// \retval <0  ȡʧܡ
int MotionDetectGetCaps(MOTION_DETECT_CAPS * pCaps);

/// @} end of group

#ifdef __cplusplus
}
#endif

#endif 
